package FI2.Arnold;
/**{p}
 * -- FI2.Arnold --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi tratti dal libro di Arnold-Gosling
 */

/**{f}
 * Battery.java
 * Arnold-Gosling esercizio 3.7
 *
 * @version 1.01 97/10/22
 * @author M.Moro DEI UPD
 */

/**{c}
 * Serbatoio con batteria elettrica
 * @see EnergySource 
 */
public class Battery extends EnergySource
{
    private float maxVolt;      // tensione ricarica
    private float volt;         // tensione attuale

    /**[c]
     * Costruttore con carica
     * @param set  carica
     */
    public Battery(float set)
    {
        maxVolt = volt = set;
        levelPercentage = 100;
        // diagnostica
        System.out.println("Battery maxVolt=" + maxVolt);
    } //[c] Battery

    /**[m]
     * Ricarica
     */
    public void charge()
    {
        volt = maxVolt;
        levelPercentage = 100;
    } //[m] charge

    /**[m]
     * Impostazione (per prove) 
     * @param val  valore di impostazione
     */
    public void set(float val)
    {
        volt = val;
        levelPercentage = (int)(val*100.0/((float)maxVolt));
    } //[m] set

    /**[m]
     * @see EnergySource#empty()
     * @return true se vuoto (Volt < 60%)
     */
    boolean empty()
    {
        System.out.println("Battery Volt=" + volt);
        return levelPercentage < 60;
    }  //[m] empty

    /**[m]
     * @see EnergySource#Full()
     */
    void full()
    {
        charge();
        // diagnostica
        System.out.println("Battery Full Volt=" + volt);
    } //[m] full

    /**[m]
     * Conversione a stringa -
     * fornisce il livello di tensione
     * @return la stringa
     */
    public String toString()
    {
        return String.valueOf(volt)+" Volt livello=" + levelPercentage + "%";
    } //[m] toString

} //{c} Battery


