package FI2.Arnold;
/**{p}
 * -- FI2.Arnold --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi tratti dal libro di Arnold-Gosling
 */

/**{f}
 * GasTank.java
 * Arnold-Gosling esercizio 3.7
 *
 * @version 1.01 97/10/22
 * @author M.Moro DEI UPD
 */

/**{c}
 * Serbatoio a benzina
 * @see EnergySource
 */
public class GasTank extends EnergySource
{
    private long maxCl;     // capienza
    private long cl;        // centilitri di benzina attuali

    /**[c]
     * Costruttore con quantita` carburante
     * @param set  centilitri messi
     */
    public GasTank(long set)
    {
        maxCl = cl = set;
        levelPercentage = 100;
        // diagnostica
        System.out.println("GasTank maxCl=" + maxCl);
    } //[c] GasTank

    /**[m]
     * Aggiunta di carburante
     * @param add  centilitri aggiunti
     */
    public void gasAdd(long add)
    {
        cl += add;
        levelPercentage = (int)(cl*100.0/((float)maxCl));
    } //[m] gasAdd

    /**[m]
     * @see EnergySource#empty()
     * @return true se vuoto (cl < 50)
     */
    boolean empty()
    {
        // diagnostica
        System.out.println("GasTank cl=" + cl);
        return cl < 50;
    } //[m] empty

    /**[m]
     * @see EnergySource#full()
     */
    void full()
    {
        cl = maxCl;
        levelPercentage = 100;
        // diagnostica
        System.out.println("GasTank full cl=" + cl);
    } //[m] full

    /**[m]
     * Conversione a stringa -
     * fornisce il contenuto del serbatoio
     * @return  la stringa
     */
    public String toString()
    {
        return String.valueOf(cl)+" cl livello=" + levelPercentage + "%";
    } //[m] toString

} //{c} GasTank

