package FI2.Arnold;
/**{p}
 * -- FI2.Arnold --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi tratti dal libro di Arnold-Gosling
 */

/**{f}
 * PassengerVehicle.java
 * Arnold-Gosling esercizio 3.1 -
 * PassengerVehicle: estensione di Vehicle (vedi es2_08.java)
 *
 * @version 1.01 97/10/22
 * @author M.Moro DEI UPD
 */

/**{c}
 * Un veicolo con passeggeri
 * @see Vehicle2
 */
public class PassengerVehicle extends Vehicle2
{
    static private int maxPas;
        // massimo numero passeggeri
    private int pas;
        // numero passeggeri corrente

    /**[m][s]
     * Imposta numero massimo passeggeri
     * @param mPas  numero passeggeri
     */
    static public void setMaxPas(int mPas)
    {
        maxPas = mPas;
    } //[m] setMaxPas

    /**[c]
     * Costruttore di default 
     */
    public PassengerVehicle() {
//        super();  implicito!!
        if (vId == 0)
            // diagnostica
            System.out.println("PassengerVehicle()");
        /* pas = 0; */
    } //[c] PassengerVehicle

    /**[c]
     * Costruttore completo
     * @param pas  numero passeggeri
     * @param id  identificativo
     * @param owner  proprietario
     */
    public PassengerVehicle(int pas, long id, String owner)
    {
        super(id, owner);
            // deve essere la prima istruzione
        if (vId == 0)
            // diagnostica
            System.out.println(
"PassengerVehicle(" + pas + ", " + id + ", " +
              owner + ")");
        this.pas = pas;
    } //[c] PassengerVehicle

    /**[c]
     * Costruttore parziale
     * @param pas  numero passeggeri
     * @param owner  proprietario
     */
    public PassengerVehicle(int pas, String owner)
    {
        this(pas, 0L, owner);
            // deve essere la prima istruzione
        if (vId == 0)
            // diagnostica
            System.out.println(
"PassengerVehicle(" + pas + ", " +
              owner + ")");
    } //[c] PassengerVehicle

    /**[c]
     * Costruttore con passeggeri
     * @param pas  numero passeggeri
     */
    public PassengerVehicle(int pas)
    {
        this(pas, 0L, "<nowoner>");
            // deve essere la prima istruzione
        if (vId == 0)
            // diagnostica
            System.out.println(
  "PassengerVehicle(" + pas + ")");
    } //[c] PassengerVehicle

    /**[m]
     * Legge numero passeggeri corrente
     * @return  passeggeri
     */
    public int getPas()
    {
        return pas;
    } //[m] getPas

    /**[m]
     * Imposta numero passeggeri corrente
     * @param pas  numero passeggeri corrente
     */
    public void setPas(int pas)
    {
        this.pas = pas;
    } //[m] setPas

    /**[m]
     * Conversione a stringa -
     * fornisce il contenuto dei campi
     * @return  la stringa
     */
    public String toString()
    {
        return super.toString() +
          " {PassengerVehicle} maxPas=" + maxPas +
          ", pas=" + pas;
    } //[m] toString

    /**[m][s]
     * metodo di collaudo
     * @param args[]  non usato
     */
    static public void main(String[] args)
    {
        PassengerVehicle boh = new PassengerVehicle();
        PassengerVehicle mine = new
          PassengerVehicle(4, "Sergio Rossi");
        Vehicle2 reduced = new
          PassengerVehicle(5, 34, "Mario Bianchi");
            // polimorfismo

        System.out.println("boh: " + boh);
        System.out.println("mine: " + mine);
        System.out.println("reduced: " + reduced);

        mine.setSpeed(3.5f);
        mine.setDir(-390);
            // funzioni ereditate
        mine.setPas(6);
        System.out.println("Dopo mine: vel=" +
          mine.getSpeed() + " dir=" + mine.getDir()
          + " pas=" + mine.pas);
            // pas e` visibile per un PassengerVehicle (mine)
//        System.out.println("reduced: pas=" + reduced.pas);
            // Questo invece darebbe errore compile-time
            // perche' pas non e` visibile per
            // un Vehicle2 (reduced)
    } //[m][s] main

} //{c} PassengerVehicle

