package FI2.Arnold;
/**{p}
 * -- FI2.Arnold --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi tratti dal libro di Arnold-Gosling
 */

/**{f}
 * PingPong.java
 * Arnold-Gosling paragrafo 9.1
 * esempio d'uso di Thread
 *
 * @version 1.02 99/09/28
 * @author M.Moro DEI UPD
 */

/**{c}
 * Output concorrente - 
 * esempio d'uso di Thread: due thread visualizzano
 * indipendentemente una stringa
 */
public class PingPong extends Thread
{
    private String word;  // la parola da visualizzare
    private int delay;    // quanto attendere

    /**[c]
     * Costruttore 
     * @param whatToSay  stringa da visualizzare
     * @param delayTime  ritardo
     */
    public PingPong(String whatToSay, int delayTime)
    {
        word = whatToSay;
        delay = delayTime;
    } //[c] PingPong

    /**[m]
     * attivatore
     */
    public void run()
    {
        int count = 1;  // ogni thread ha il suo conteggio
        try
        {
            for(;;)
            {
                System.out.print(word + "[" + 
                  (count++) + "] ");
                if (count % 3 == 1)
                    System.out.print("\n");
                sleep(delay);  // attesa
            } //for
        }
        catch (InterruptedException e)
        {
            return;  //thread terminato
        } //catch
    } //[m] run

    /**[m][s]
     * metodo di collaudo
     * @param args[]  non usato
     */
    static public void main(String[] args)
    {
        System.out.println("Attiva i due thread");
        new PingPong("ping" , 330).start();  // 1/3 s
        new PingPong("PONG" , 1000).start();  // 1 s
        System.out.println("Attivati i due thread");
        System.out.println("Battere <Control>-C per terminare");
    } //[m][s] main

} //{c} PingPong
