package FI2.Dictionary;
/**{p}
 * -- FI2.Dictionary --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Dizionari
 */

/**{f}
 * AKeyComp.java
 * comparatore per collaudi con chiave a 6 caratteri
 *
 * @version 1.00 98/09/08
 * @version 1.01 99/11/16 -
 * aKeyComp -> AKeyComp
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidElementException;
import FI2.Util.Comparator;

/**{c}
 * implementa Comparator per confrontare chiavi
 * stringhe di 6 caratteri secondo l'usuale ordinamento
 * lessicografico
 * @see Comparator
 */
public class AKeyComp implements Comparator 
{
    /**[c]
     * costruttore di default nullo
     */
    public AKeyComp(){}
    
    /**[m]
     * @see Comparator
     */
    public boolean isEqualTo(Object x1, Object x2)
      throws InvalidElementException 
    {
        check(x1,x2);
        return ((String)x1).substring(0,6).equals(
          ((String)x2).substring(0,6)); 
    } //[m] isEqualTo

    /**[m]
     * @see Comparator
     */
    public boolean isGreaterThan(Object x1, Object x2)
      throws InvalidElementException 
    {
        check(x1,x2); 
        return ((String)x1).substring(0,6).compareTo(
          ((String)x2).substring(0,6)) > 0; 
    } //[m] isGreaterThan
    
    /**[m]
     * @see Comparator
     */
    public boolean isLessThan(Object x1, Object x2)
      throws InvalidElementException 
    {
        check(x1,x2);
        return ((String)x1).substring(0,6).compareTo(
          ((String)x2).substring(0,6)) < 0; 
    } //[m] isLessThan
    
    /**[m]
     * @see Comparator
     */
    public boolean isGreaterThanOrEqualTo(
      Object x1, Object x2)
      throws InvalidElementException
    {
        check(x1,x2);
        return ((String)x1).substring(0,6).compareTo(
          ((String)x2).substring(0,6)) >= 0;    
    } //[m] isGreaterThanOrEqualTo
    
    /**[m]
     * @see Comparator
     */
    public boolean isLessThanOrEqualTo(Object x1, Object x2)
        throws InvalidElementException
    {
        check(x1,x2);
        return ((String)x1).substring(0,6).compareTo(
          ((String)x2).substring(0,6)) <= 0;    
    } //[m] isLessThanOrEqualTo

    /**[m]
     * @see Comparator
     */
    public boolean isComparable(Object x)
    {
        if (x==null)
            return false;
        try
        {
            String tmp = (String)x;
        }
        catch (ClassCastException e)
        {
            return false;
        } //try-catch
        if (x != null)
            return true;
        else
            return false;
    } //[m] isComparable

    // metodi di supporto

    /*[m]
     * verifica se entrambi gli oggetti sono nonnulli
     * e stringa
     * @param x1  primo oggetto
     * @param x2  secondo oggetto
     * @exception InvalidElementException
     * se uno o entrambi gli oggetti nulli
     */
    private void check(Object x1, Object x2) 
      throws InvalidElementException 
    {
        if ((x1==null) || (x2==null)) throw
           new InvalidElementException(
           "Comparatore applicato ad oggetto nullo");
        try
        {
            String tmp = (String)x1;
        }
        catch (ClassCastException e){
            throw new 
            InvalidElementException("Chiave non stringa");
        } //try-catch
        try
        {
            String tmp = (String)x2;
        }
        catch (ClassCastException e){
            throw new 
            InvalidElementException("Chiave non stringa");
        } //try-catch
    } //[m] check

} //{c} AKeyComp
