package FI2.Dictionary;
/**{p}
 * -- FI2.Dictionary --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Dizionari
 */

/**{f}
 * Dictionary.java
 * interfaccia dizionario non ordinato -
 * derivata da Dictionary della v 1.x 
 *
 * @version 2.00 00/09/25
 * @author M.Moro DEI UPD
 */

import FI2.Set.KeyBasedContainer;
import FI2.Set.ObjectIterator;
import FI2.Exceptions.InvalidKeyException;

/**{i}
 * dizionario -
 * puo` contenere anche piu` elementi con la stessa
 * chiave
 * @see InspectableDictionary
 * @see KeyBasedContainer
 */
public interface Dictionary 
  extends InspectableDictionary, KeyBasedContainer 
{
    /**[m][a]
     * inserimento di un elemento con chiave -
     * se la chiave e` gia` presente, la inserisce
     * dopo l'ultima occorrenza
     * @param key  chiave associata all'elemento
     * @param element  elemento da inserire
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public void insertItem (Object key, Object element)
      throws InvalidKeyException;

    /**[m][a]!!
     * aggiorna l'elemento con chiave fornita -
     * se piu` elementi hanno la stessa chiave, aggiorna
     * solo il primo (quindi ha maggior senso con dizionario
     * a chiavi uniche)
     * @param key  chiave di ricerca
     * @param element  elemento da inserire
     * @return l'elemento sostituito se chiave trovata,
     *         NO_SUCH_KEY altrimenti
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public Object replaceElement (Object key, Object element)
      throws InvalidKeyException;

    /**[m][a]
     * rimuove l'elemento con chiave fornita -
     * in caso di chiavi multiple, rimuove la prima
     * occorrenza
     * @param key  chiave di ricerca
     * @return l'elemento rimosso se chiave trovata,
     *         NO_SUCH_KEY altrimenti
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public Object removeElement(Object key)
      throws InvalidKeyException;

    /**[m][a]
     * rimuove gli elementi con chiave fornita e ne
     * fornisce un'enumerazione
     * @param key  chiave di ricerca
     * @return iteratore (eventualmente vuoto) 
     *         delle chiavi rimosse
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public ObjectIterator removeAllElements(Object key)
      throws InvalidKeyException;

} //{i} Dictionary
