package FI2.Dictionary;
/**{p}
 * -- FI2.Dictionary --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Dizionari
 */

/**{f}
 * InspectableOrderedDictionary.java
 * interfaccia dizionario read-only 
 * con ordinamento totale -
 * derivata da OrderedDictionary della v 1.x 
 *
 * @version 2.00 00/09/25
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidKeyException;

/**{i}
 * dizionario con metodi di sola lettura
 * e con ordinamento totale -
 * puo` contenere anche piu` elementi con la stessa
 * chiave
 * @see InspectableDictionary
 */
public interface InspectableOrderedDictionary 
  extends InspectableDictionary
{

    /**[m][a]
     * ricerca la maggior chiave <= di quella fornita,
     * associata ad un elemento nel dizionario
     * @param key  chiave di ricerca
     * @return la maggior chiave <= key 
     *         se un item con tale chiave e` presente,
     *         NO_SUCH_KEY altrimenti
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public Object closestKeyBefore (Object key) 
      throws InvalidKeyException;
  
    /**[m][a]
     * ricerca la maggior chiave <= di quella fornita
     * e ne ritorna un elemento associato -
     * se la chiave e` presente, restituisce la prima 
     * occorrenza
     * @param key  chiave di ricerca
     * @return l'elemento associato alla maggior chiave <= key 
     *         se un item con tale chiave e` presente
     *         NO_SUCH_KEY altrimenti
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public Object closestElemBefore (Object key) 
      throws InvalidKeyException;
  
    /**[m][a]
     * ricerca la minor chiave >= di quella fornita,
     * associata ad un elemento nel dizionario
     * @param key  chiave di ricerca
     * @return la minor chiave >= key 
     *         se un item con tale chiave e` presente,
     *         NO_SUCH_KEY altrimenti
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public Object closestKeyAfter (Object key) 
      throws InvalidKeyException;
  
    /**[m][a]
     * ricerca la minor chiave >= di quella fornita,
     * e ne ritorna un elemento associato -
     * se la chiave e` presente, restituisce l'ultima
     * occorrenza
     * @param key  chiave di ricerca
     * @return l'elemento associato alla minor chiave >= key 
     *         se un item con tale chiave e` presente,
     *         NO_SUCH_KEY altrimenti
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    public Object closestElemAfter (Object key) 
      throws InvalidKeyException;
  
} //{i} InspectableOrderedDictionary
