package FI2.Dictionary;
/**{p}
 * -- FI2.Dictionary --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Dizionari
 */

/**{f}
 * LocatorDictionary.java
 * interfaccia dizionario non ordinato
 * con supporto riferimenti (Locator)
 *
 * @version 1.00 00/09/25
 * @author M.Moro DEI UPD
 */

import FI2.Set.LocatorIterator;
import FI2.Set.LocatorKeyBasedContainer;
import FI2.Exceptions.InvalidKeyException;

/**{i}
 * dizionario con riferimenti -
 * puo` contenere anche piu` elementi con la stessa
 * chiave
 * @see InspectableLocatorDictionary
 * @see LocatorKeyBasedContainer
 * @see Dictionary
 */
public interface LocatorDictionary 
  extends InspectableLocatorDictionary, 
  LocatorKeyBasedContainer, Dictionary 
{
    /**[m][a]
     * rimuove tutti gli elementi la cui
     * chiave e` quella dell'elemento riferito
     * dal Locator fornito
     * @param key  chiave da cercare
     * @exception InvalidKeyException
     * chiave illegale per il dizionario
     */
    LocatorIterator removeAll(Object key)
      throws InvalidKeyException;
  
} //{i} LocatorDictionary
