package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esempi vari
 */

/**{f}
 * ArrayCollection.java
 * Esercizio suppl. 1.16 -
 * implementazione di contenitore con
 * conteggio degli elementi
 *
 * @version 1.00 00/10/04
 * @author M.Moro DEI UPD
 */

/**{c}
 * Collezione di interi con conteggio elementi
 * ed enumeratore
 */
public class ArrayCollection implements Sizeable
{
    protected int[] vec;  // array di supporto
    protected int size;  // numero elementi

    /**[c]
     * costruttore
     * @param dim  dimensione array
     * @return descrizione del contenuto
     */
    public ArrayCollection(int dim) 
    { 
        vec = new int[dim];
        size = 0;
    } //[c]
    
    /**[m]
     * numero elementi
     * @return elementi presenti
     */
    public int size() { return size; }
    
    /**[m]
     * crea enumeratore
     * @return l'enumeratore creato
     */
    public java.util.Enumeration elements()
    {
        return new IndexedEnum() 

        /**{c}{l}
         * classe enumeratore
         * @see IndexedEnum
         */
        {
            {
                // inizializzatore
                coll = ArrayCollection.this;
            }
            
            /**[m]
             * @see java.util.Enumeration
             */
            public Object nextElement()
            {
                if (pos >= size)
                    throw new java.util.NoSuchElementException(
                      "pos = "+pos);
                return new Integer(vec[pos++]);
            }
        }; //{c}{l}
        
    }//[m] elements
    
    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String args[])
    {
        ArrayCollection ac = new ArrayCollection(10);
        for (int i=0; i<6; i++)
            ac.vec[i] = i+10;
        ac.size = 6;
        java.util.Enumeration en = ac.elements();
        while (en.hasMoreElements())
            System.out.println("Element: "+en.nextElement());
    }
} //{c} ArrayCollection
