package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi di verifica
 */

/**{f}
 * Bits.java
 * Esercizio 1.2 -
 * realizzazione di un ADT per sequenze di 32 bit
 *
 * @version 1.00 99/09/26
 * @author M.Moro DEI UPD
 */

/**{c}
 * Memorizza una sequenza di 32 bit in un intero
 */
public class Bits 
{
    // la rappresentazione interna
    private int val;

    // costruttori

    /**[c]
     * costruttore di default
     */
    public Bits()
    { val = 0; } 

    /**[c]
     * costruttore base
     * @param sVal  valore come stringa
     */
    public Bits(String sVal)
    {
        val = 0;
        for (int i=0; i<sVal.length(); i++)
            switch (sVal.charAt(i))
            {
            case '0':
                val = (val << 1);
                break;
            case '1':
                val = (val << 1) | 1;
                break;
            default:
                // carattere illegale: ignora
                break;
            } // switch
    } //[c] Bits

    /**[c]
     * costruttore di supporto ai metodi statici
     * @param v  valore da assegnare
     */
    private Bits(int v)
    {  val = v; }

    // metodi esportati

    /**[m]
     * and bitwise d'istanza
     * @param sndB  secondo Bits
     */
    public void and(Bits sndB)
    { val &= sndB.val; } 

    /**[m]
     * and bitwise statico
     * @param fstB  primo Bits
     * @param sndB  secondo Bits
     * @return Bits risultato
     */
    public static Bits and(Bits fstB, Bits sndB)
    { return new Bits (fstB.val & sndB.val); } 

    /**[m]
     * or bitwise d'istanza
     * @param sndB  secondo Bits
     */
    public void or(Bits sndB)
    { val |= sndB.val; } 

    /**[m]
     * or bitwise statico
     * @param fstB  primo Bits
     * @param sndB  secondo Bits
     * @return Bits risultato
     */
    public static Bits or(Bits fstB, Bits sndB)
    { return new Bits (fstB.val | sndB.val); } 

    /**[m]
     * not bitwise d'istanza
     */
    public void not()
    { val = ~val; } 

    /**[m]
     * not bitwise statico
     * @param b  Bits da negare
     * @return Bits risultato
     */
    public static Bits not(Bits b)
    { return new Bits (~b.val); } 

    /**[m]
     * query del bit
     * @param idx  indice del bit
     * @return Bits risultato
     */
    public boolean bit(int idx)
    { return (val & (1 << (idx % 32))) != 0; } 

    /**[m]
     * @param sndB  secondo Bits
     * @return true se le corrispondenti componenti
     * sono eguali
     */
    public boolean equals(Bits sndB)
    {  return val == sndB.val; }

    /**[m]
     * conversione a stringa
     * @return descrizione del contenuto
     */
    public String toString()
    {
        String tmp = "{Bits} val=";
        int i;
        for (i=31; !bit(i) && i>=0; i--);
            // salta 0 non significativi
        if (i<0)
            // valore nullo
            tmp += "0";
        else
            for (; i>=0; i--)
                tmp += bit(i) ? "1" : "0";
        // potrebbe essere piu` efficiente utilizzare
        // uno StringBuffer anziche' uno String
        return tmp;
    } //[m] toString

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
    {
        System.out.println("Bits nullo: " + new Bits());
        Bits myBits1 = new Bits("100001");
        Bits myBits2 = new Bits("1101");

        System.out.println("100001 bit(5) = " + myBits1.bit(5));
        System.out.println("100001 bit(4) = " + myBits1.bit(4));
        System.out.println("100001 bit(0) = " + myBits1.bit(0));

        System.out.println("100001 & 1101 = " + and(myBits1, myBits2));
        System.out.println("100001 | 1101 = " + or(myBits1, myBits2));
        System.out.println("~ 100001 = " + not(myBits1));
        myBits1.or(new Bits("1000"));
        System.out.println("Dopo 100001 | 1000 = " + myBits1);
        System.out.println("bits1 e` " + 
          (myBits1.equals(myBits2) ? "eguale a" : "diverso da") + " bits2");
    } //[m][s] main

} //{c} Bits

