package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi di verifica
 */

/**{f}
 * Cerchio.java
 * Esercizio 2.3 -
 * Una figura cerchio
 *
 * @version 1.00 99/09/26
 * @author M.Moro DEI UPD
 */

import java.io.*;

/**{c}
 * Memorizza il raggio del cerchio
 * @see Figura
 */
public class Cerchio extends Figura
{
    // la rappresentazione interna
    private double raggio;

    // costruttori

    /**[c]
     * costruttore base
     * @param c  centro
     * @param r  raggio
     *
     */
    public Cerchio(PointE c, double r)
    { 
        super(c.xVal(), c.yVal());  // centro
        raggio = r;
    } //[c]

    // metodi esportati

    /**[m]
     * rotazione
     * @see SuFigura
     */
    public void rotate(double angolo)
    { } // nulla

    /**[m]
     * zoom
     * @see SuFigura
     */
    public void zoom(double fattore)
    { raggio *= fattore; }

    /**[m]
     * show
     * @see SuFigura
     */
    public void show()
    { 
        System.out.println("{Cerchio} centro=" + 
          centro);
        System.out.println("raggio=" + raggio);
    } //[m] show

    /**[m]
     * perimetro
     * @return il perimetro
     */
    public double perim()
    { return raggio*2.0*Math.PI; }

    /**[m]
     * area
     * @return l'area
     */
    public double area()
    { return raggio*raggio*Math.PI; }

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
      throws IOException
    {
        PointE c = new PointE(1.0, 2.0);
        Cerchio cc = new Cerchio(c, 4.0);
        System.out.println("Cerchio originario");
        cc.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro originario = " + cc.perim());
        System.out.println("Area originario = " + cc.area());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        cc.move(new PointE(3.0, 5.0));
        System.out.println("Cerchio dopo move (3,5)");
        cc.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        cc.rotate(Math.PI/2);
        System.out.println("Cerchio dopo rot(PI/2)");
        cc.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + cc.perim());
        System.out.println("Area attuale = " + cc.area());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        cc.zoom(0.5);
        System.out.println("Cerchio dopo zoom(1/2)");
        cc.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + cc.perim());
        System.out.println("Area attuale = " + cc.area());
    } //[m][s] main

} //{c} Cerchio

