package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esempi vari
 */

/**{f}
 * CheckBalance.java
 * Esercizio 4.4 -
 * Verifica bilanciamento parentesi
 *
 * @version 1.00 99/10/22
 * @author M.Moro DEI UPD
 */

import FI2.Linear.Stack;
import FI2.Linear.ArrayStack;
import FI2.Util.FI2Sys;
import java.io.*;


/**{c}
 * Verifica di parentesi bilanciate
 * con metodo ricorsivo e stack esplicito
 */
public class CheckBalance
{
    private static int startix;
      // posizione di scorrimento
    private static Stack st;
    private static String expr;

    /**[s]
     * inizializzazione static
     */
    static
    {
        st = new ArrayStack();
    } //[s]

    /**[m]
     * metodo di verifica
     */
    public static void check()
    {
        for (; startix<expr.length(); startix++)
        {
            if (expr.charAt(startix) == '(')
            {
                // trovata aperta parentesi
                st.push(new Integer(startix++));
                check();
                int first = ((Integer)st.pop()).intValue();
                if (startix < expr.length())
                    // trovata chiusa parentesi
                    FI2Sys.out.println(
                      "Coppia di parentesi in posizioni " + 
                      first + " e " + startix);
                else
                {
                    FI2Sys.out.println("La parentesi aperta in posizione " +
                      first + " non e` bilanciata!");
                    return;
                }
            }
            else if (expr.charAt(startix) == ')')
                // trovata chiusa parentesi
                if (st.size() != 0)
                    // termina chiamata ricorsiva
                    break;
                else
                    // parentesi chiusa non bilanciata
                    FI2Sys.out.println("La parentesi chiusa in posizione " +
                      startix + " non e` bilanciata!");
        } //for
    } //[m] check

    /**[m]
     * avvia check
     * @param ex  stringa-espressione
     */
    public static void runCheck(String ex)
    {
        expr = ex;
        startix = 0;
        check();
    } //[m] runCheck

    /**[m][s]
     * metodo di collaudo
     * @param args[0]  nome file (opzionale)
     */
    public static void main(String[] args)
      throws IOException
    {
        InputStream in;
        String str;

        if (args.length == 0)
        {
            // default, stdin
            in = System.in;
            FI2Sys.out.println(
  "Verifica parentesi, battere una espressione per riga:");
        }
        else
            in = new FileInputStream(args[0]);

        BufferedReader re = new BufferedReader(new
          InputStreamReader(in));
        while ((str = re.readLine()) != null)
            runCheck(str);
    } //[m][s] main

} //{c} ChecckBalance

