package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esempi vari
 */

/**{f}
 * ContainerHelper.java
 * Esercizio 5.4 -
 * Meccanismo per collegare un attivatore 
 * indiretto ad un contenitore
 *
 * @version 1.00 99/10/22
 * @author M.Moro DEI UPD
 */

import FI2.Set.Container;

/**{c}
 * Attiva uno dei metodi per un oggetto che
 * implementa l'interfaccia ContainerActivator
 */
public class ContainerHelper
{
    public static final int SETEMPTYCOM = 0; 
    public static final int SETDOUBLECOM = 1; 
      // codici comandi di attivazione
    private ContainerActivator act;

    /**[c]
     * costruttore base
     * @param a  attivatore da associare
     */
    public ContainerHelper (ContainerActivator a)
    {  act = a; }

    /**[m]
     * metodo di impostazione dell'attivatore
     * @param a  attivatore da associare
     */
    public void setActivator(ContainerActivator a)
    {  act = a; }

    /**[m]
     * metodo di attivazione dell'attivatore
     * @param command  indice del metodo da attivare
     * @return Container  nuovo contenitore dopo l'operazione
     * attivata (coincide con il contenitore originario 
     * se con approccio ad oggetti mutabili)
     */
    public Container activate(int command)
    {
        switch(command)
        {
          case SETEMPTYCOM:
            return act.setEmpty();
          case SETDOUBLECOM:
            return act.setDouble();
          default:
            return null;
        } //switch
    } //[m] activate

} //{c} ContainerHelper

