package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esempi
 */

/**{f}
 * Pixel.java
 *
 * realizzazione di una classe derivata da PointE che 
 * rappresenta un pixel sullo schermo
 *
 * @version 3.00 01/09/30
 * @author M.Moro DEI UPD
 */

/**{c}
 * Realizzazione di un pixel come punto cartesiano 
 * con colore
 * @see PointE 
 */
public class Pixel extends PointE
{
    Color col;  // colore del pixel

    /**[c]
     * costruttore base
     * @param xVal  ascissa
     * @param yVal  ordinata
     * @param cVal  colore
     */
    public Pixel(double xVal, double yVal, int cVal) {
        super(xVal, yVal);
        col = new Color(cVal);
    } //[c] Pixel

    /**[c]
     * costruttore ridotto, senza colore
     * @param xVal  ascissa
     * @param yVal  ordinata
     */
    public Pixel(double xVal, double yVal) {
        this(xVal, yVal, Color.WHITE);
    } //[c] Pixel

    /**[m]
     * luminosita` del colore
     * metodo necessario perche` non ereditabile
     * mancando l'ereditarieta` multipla
     * @return luminosita`
     */
    public int brightness() {
        return col.brightness();
    } //[m] brightness

    /**[m]
     * ridefinisce il metodo Object.equals()
     * @param sndP  secondo pixel di confronto
     * @return true se componenti eguali
     */
    public boolean equals(Object sndP)
    {
        return super.equals(sndP) &&
          col.equals(((Pixel)sndP).col);
    } //[m] equals

    /**[m]
     * conversione a stringa
     * @return coordinate e colore
     */
    public String toString()
    {
        return "{Pixel} " + super.toString() + " " + col;
    } //[m] toString

    /**[m][s]
     * metodo di collaudo
     * @param args[0]  non usato
     */
    public static void main(String[] args)
    {
        PointE p1 = new Pixel(3.0, 4.0, Color.BLUE);
        Pixel p2 = new Pixel(-2.0, 5.0);
//        Pixel p3 = (Pixel)new PointE(8.0, -4.0);
            /* il cast sarebbe necessario ma e` errato
            interpretare un oggetto di superclasse come
            di tipo sottoclasse: questa dichiarazione
            farebbe sollevare una eccezione nella successiva
            chiamata a p3.toString() */

        System.out.println("Il PointE p1 e` " + p1);
        System.out.println("Il Pixel p2 e` " + p2);
//        System.out.println("Il Pixel p3 e` " + p3);
            // vedi sopra
        System.out.println("Distanza p2-p1 " + p2.dist(p1));
        p2.rot(Math.PI);
        System.out.println("L'opposto di p2 e` " + p2);
        Pixel p4 = new Pixel(3.0, 4.0, Color.BLUE);  // come p1
        System.out.println("p4 e` " +
          (p4.equals(p1) ? "eguale" : "non eguale") + " a p1");
        
    } //[m][s] main

} //{c} Pixel

