package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esempi vari
 */

/**{f}
 * PointInputStream.java
 * Esercizio 3.4 -
 * Una classe di tipo DataInputStream per leggere Point
 *
 * @version 1.00 99/10/17
 * @author M.Moro DEI UPD
 */

import java.io.*;
import java.util.Random;

/**{c}
 * Aggiunge a DataInputStream la lettura di oggetti di
 * tipo Point
 * @see DataInputStream
 */
public class PointInputStream extends DataInputStream
{
    /**[c]
     * costruttore base
     * @see DataInputStream
     */
    public PointInputStream(InputStream in)
    {
        super(in);
    } //[c] PointInputStream

    /**[m]
     * metodo di lettura di un Point
     * @return un nuovo oggetto Point con le
     *         componenti lette dallo stream
     */
    public Point readPoint()
      throws IOException
    {
        return new Point(readDouble(), readDouble());
    }

    /**[m][s]
     * metodo di supporto che salva 10 numeri casuali
     * o 10 valori fissi in un file 
     * @param args[0]  nome file
     * @param args[1]  casuali se presente
     */
    public static void main(String[] args)
      throws IOException
    {
        if (args.length > 0)
        {
            // scrittura file
            DataOutputStream dout = new DataOutputStream(
              new FileOutputStream(args[0]));
            if (args.length > 1)
            {
                Random rn = new Random();

                for (int i=1; i<=10; i++)
                    dout.writeDouble(rn.nextDouble()*10.0);
            }
            else
            {
                for (int i=0; i<10; i++)
                    dout.writeDouble(((double)(i+1)) + ((double)(i+1))/10.0);
            }
        }
    } //[m][s] main

} //{c} PointInputStream

