package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi di verifica
 */

/**{f}
 * Quadrato.java
 * Esercizio 2.3 -
 * Un quadrato come rettangolo
 *
 * @version 1.00 99/09/26
 * @author M.Moro DEI UPD
 */

import java.io.*;

/**{c}
 * Tiene conto dei lati eguali e ortogonali
 * @see Rettangolo
 */
public class Quadrato extends Rettangolo
{
    // costruttori

    /**[c]
     * costruttore base
     * @param vs  vertice basso-sinistro
     * @param angolo  angolo lato inferiore
     * @param l  lato 
     *
     */
    public Quadrato(PointE vs, double angolo, double l)
    { 
        super(vs, angolo, l, l);
    } //[c]

    // metodi esportati

    /**[m]
     * perimetro
     * @return il perimetro
     */
    public double perim()
    { 
        return vertici[0].dist(vertici[1]) * 4.0;
    } //[m] perim

    /**[m]
     * area
     * @return l'area
     */
    public double area()
    { 
        double l = 
          vertici[0].dist(vertici[1]);
        return l*l;
    } //[m] area

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
      throws IOException
    {
        PointE vs = new PointE(1.0, 2.0);

        Quadrato q = new Quadrato(vs, Math.PI/8, 5.0);
        System.out.println("Quadrato originario");
        q.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro originario = " + q.perim());
        System.out.println("Area originaria = " + q.area());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        q.move(new PointE(3.0, 5.0));
        System.out.println("Quadrato dopo move (3,5)");
        q.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + q.perim());
        System.out.println("Area attuale = " + q.area());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        q.rotate(Math.PI/4);
        System.out.println("Rettangolo dopo rot(PI/4)");
        q.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + q.perim());
        System.out.println("Area attuale = " + q.area());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        q.zoom(2.5);
        System.out.println("Rettangolo dopo zoom(2.5)");
        q.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + q.perim());
        System.out.println("Area attuale = " + q.area());
    } //[m][s] main

} //{c} Quadrato

