package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi di verifica
 */

/**{f}
 * Rettangolo.java
 * Esercizio 2.3 -
 * Un poligono rettangolo
 *
 * @version 1.00 99/09/26
 * @author M.Moro DEI UPD
 */

import java.io.*;

/**{c}
 * Tiene conto dei lati paralleli eguali e ortogonali
 * @see Poligono
 */
public class Rettangolo extends Poligono
{
    // costruttori

    /**[m]
     * metodo di supporto per il costruttore
     * @param vs  vertice basso-sinistro
     * @param angolo  angolo lato inferiore
     * @param la  lato a
     * @param lb  lato b
     *
     */
    public static PointE[] rVert(PointE vs, double angolo, double la, double lb)
    { 
        DVect v[] = new DVect[4];
        v[0] = new DVect(vs.xVal(), vs.yVal(), 0);
        // gli altri vertici sono ottenuti per somma
        // con un vettore-lato inclinato
        v[1] = new DVect(la, 0.0, 0);
        v[1].rot(angolo);
        v[1] = v[0].add(v[1]);

        v[2] = new DVect(0.0, lb, 0);
        v[2].rot(angolo);
        v[2] = v[1].add(v[2]);

        v[3] = new DVect(-la, 0.0, 0);
        v[3].rot(angolo);
        v[3] = v[2].add(v[3]);

        return v;
    } //[m] rVert

    /**[c]
     * costruttore base
     * @param vs  vertice basso-sinistro
     * @param angolo  angolo lato inferiore
     * @param la  lato a
     * @param lb  lato b
     *
     */
    public Rettangolo(PointE vs, double angolo, double la, double lb)
    { 
        super(4, rVert(vs, angolo, la, lb));
    } //[c]

    // metodi esportati

    /**[m]
     * perimetro
     * @return il perimetro
     */
    public double perim()
    { 
        return (vertici[0].dist(vertici[1]) + 
          vertici[1].dist(vertici[2])) * 2.0;
    } //[m] perim

    /**[m]
     * area
     * @return l'area
     */
    public double area()
    { 
        return vertici[0].dist(vertici[1]) *
          vertici[1].dist(vertici[2]);
    } //[m] area

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
      throws IOException
    {
        PointE vs = new PointE(1.0, 2.0);

        Rettangolo r = new Rettangolo(vs, Math.PI/4, 3.0, 4.0);
        System.out.println("Rettangolo originario");
        r.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro originario = " + r.perim());
        System.out.println("Area originaria = " + r.area());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        r.move(new PointE(3.0, 5.0));
        System.out.println("Rettangolo dopo move (3,5)");
        r.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + r.perim());
        System.out.println("Area attuale = " + r.area());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        r.rotate(Math.PI/2);
        System.out.println("Rettangolo dopo rot(PI/2)");
        r.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + r.perim());
        System.out.println("Area attuale = " + r.area());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        r.zoom(3.0);
        System.out.println("Rettangolo dopo zoom(3)");
        r.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + r.perim());
        System.out.println("Area attuale = " + r.area());
    } //[m][s] main

} //{c} Rettangolo

