package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esempi vari
 */

/**{f}
 * StrWrap.java
 * Esercizio suppl. 1.15 -
 * implementazione di wrapper come
 * qualificatore e stringa
 *
 * @version 1.00 00/10/04
 * @author M.Moro DEI UPD
 */

/**{c}
 * Incapsula un valore base come qualificatore
 * e stringa -
 * in questa soluzione ci si limita ai valori
 * intero, char e boolean, potendo facilmente estendere
 * agli altri tipi base
 */
public class StrWrap implements Wrapper 
{
    // qualificatori
    private static final int NULLQUAL = 0;
    private static final int INTQUAL = 1;
    private static final int CHARQUAL = 2;
    private static final int BOOLQUAL = 3;
    
    // qualificatore e stringa
    private int qual = 0;
    private String val = "";

    public Object get()
    {
        switch(qual)
        {
          case INTQUAL:
            return new Integer(val);
          case CHARQUAL:
            return new Character(val.charAt(0));
          case BOOLQUAL:
            return new Boolean(val);
          default:
            return null;
        } // switch
    } //[m] get

    /**[m]
     * conversione a stringa
     * @return descrizione del contenuto
     */
    public String toString()
    {
        switch(qual)
        {
          case INTQUAL:
            return "Integer " + val;
          case CHARQUAL:
            return "Char " + val;
          case BOOLQUAL:
            return "Bool " + val;
          default:
            return "No value";
        } // switch
    } //[m] toString

    /**[m]
     * @see Wrapper
     */
    public Wrapper wrap(char c)
    {
        StrWrap w = new StrWrap();

        w.qual = CHARQUAL;
        w.val = new Character(c).toString();
        return w;
    } //[m] wrap

    /**[m]
     * @see Wrapper
     */
    public Wrapper wrap(int i)
    {
        StrWrap w = new StrWrap();

        w.qual = 1;
        w.val = Integer.toString(i);
        return w;
    } //[m] wrap

    /**[m]
     * @see Wrapper
     */
    public Wrapper wrap(boolean b)
    {
        StrWrap w = new StrWrap();

        w.qual = 3;
        w.val = new Boolean(b).toString();
        return w;
    } //[m] wrap

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
    {
        StrWrap w = new StrWrap();
        Wrapper w1 = w.wrap(5);
        Wrapper w2 = w.wrap('B');
        Wrapper w3 = w.wrap(false);

        System.out.println( "w=" + w + " w1=" + w1 + " w2=" + w2 + " w3=" + w3 );
        System.out.println( "w1 get=" + w1.get() + " w2 get=" + w2.get() + " w3 get=" + w3.get() );
    } //[m][s] main

} //{c} StrWrap
