package FI2.Examples;
/**{p}
 * -- FI2.Examples --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi di verifica
 */

/**{f}
 * Triangolo.java
 * Esercizio 2.3 -
 * Un poligono triangolo
 *
 * @version 1.00 99/09/26
 * @author M.Moro DEI UPD
 */

import java.io.*;

/**{c}
 * Nel triangolo il centro e` l'incrocio di due
 * meridiane
 * @see Poligono
 */
public class Triangolo extends Poligono
{
    // costruttori

    /**[c]
     * costruttore base
     * @param v  coordinate assolute dei vertici
     *
     */
    public Triangolo(PointE v[])
    { 
        super(3, v);
    } //[c]

    // metodi esportati

    /**[m]
     * area
     * @return l'area
     */
    public double area()
    { 
        double p = perim()/2.0;
        return Math.sqrt(p * (p-vertici[0].dist(vertici[1])) *
          (p-vertici[1].dist(vertici[2])) * 
          (p-vertici[2].dist(vertici[0])));
    } //[m] area

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
      throws IOException
    {
        PointE v[] = new PointE[3];
        v[0] = new PointE(1.0, 2.0);
        v[1] = new PointE(4.0, 2.0);
        v[2] = new PointE(1.0, 6.0);

        Triangolo t = new Triangolo(v);
        System.out.println("Triangolo originario");
        t.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro originario = " + t.perim());
        System.out.println("Area originaria = " + t.area());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        t.move(new PointE(3.0, 5.0));
        System.out.println("Triangolo dopo move (3,5)");
        t.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + t.perim());
        System.out.println("Area attuale = " + t.area());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        t.rotate(Math.PI/2);
        System.out.println("Triangolo dopo rot(PI/2)");
        t.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + t.perim());
        System.out.println("Area attuale = " + t.area());
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        t.zoom(3.0);
        System.out.println("Triangolo dopo zoom(3)");
        t.show();
        System.out.println("Battere RET");
        while (System.in.available() != 0)
            System.in.read();
        System.in.read();
        System.out.println("Perimetro attuale = " + t.perim());
        System.out.println("Area attuale = " + t.area());
    } //[m][s] main

} //{c} Triangolo

