package FI2.Examples.Utility;
/**{p}
 * -- FI2.Examples.Utility --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Esercizi di verifica
 */

/**{f}
 * Wrapper.java
 * Esercizio 3.1 -
 * Classi wrapper
 *
 * @version 1.00 99/10/22
 * @author M.Moro DEI UPD
 */

/**{c}
 * Wrapper di uso generale per i tipi base
 */
public class Wrapper
{
    /**[m][s]
     * versioni overloaded del wrapper
     * @param val  valore tipo base
     * @return valore wrapped
     */
    public static Object wrap(boolean val)
    { 
        return new Boolean(val);
    } //[m][s] wrap

    public static Object wrap(char val)
    { 
        return new Character(val);
    } //[m][s] wrap

    public static Object wrap(byte val)
    { 
        return new Byte(val);
    } //[m][s] wrap

    public static Object wrap(short val)
    { 
        return new Short(val);
    } //[m][s] wrap

    public static Object wrap(int val)
    { 
        return new Integer(val);
    } //[m][s] wrap

    public static Object wrap(long val)
    { 
        return new Long(val);
    } //[m][s] wrap

    public static Object wrap(float val)
    { 
        return new Float(val);
    } //[m][s] wrap

    public static Object wrap(double val)
    { 
        return new Double(val);
    } //[m][s] wrap

    /**[m][s]
     * supporto di conversione intero
     * @param obj  oggetto wrapper
     * @return valore long convertito
     * @throws IllegalArgumentException
     *  wrapper non convertibile
     */
    private static long toLong(Object obj)
      throws IllegalArgumentException
    {
        if (obj instanceof Boolean)
            throw new IllegalArgumentException (obj+
              " non convertibile a numero");
        if (obj instanceof Character)
            return (long)((Character)obj).charValue();
        if (obj instanceof Float || 
          obj instanceof Double)
            return (long)((Number)obj).doubleValue();
        return ((Number)obj).longValue();
    } //[m][s] toLong
    
    /**[m][s]
     * supporto di conversione floating
     * @param obj  oggetto wrapper
     * @return valore double convertito
     * @throws IllegalArgumentException
     *  wrapper non convertibile
     */
    private static double toDouble(Object obj)
      throws IllegalArgumentException
    {
        if (obj instanceof Boolean)
            throw new IllegalArgumentException (obj+
              " non convertibile a numero");
        if (obj instanceof Character)
            return (double)((Character)obj).charValue();
        if (obj instanceof Float || 
          obj instanceof Double)
            return ((Number)obj).doubleValue();
        return (double)((Number)obj).longValue();
    } //[m][s] toDouble

    /**[m][s]
     * versioni overloaded del unwrapper
     * @param obj  oggetto wrapper
     * @param dummy  fittizio per overloading
     * @return valore unwrapped
     * @throws IllegalArgumentException
     *  wrapper non convertibile
     */
    public static boolean unwrap(Object obj, boolean dummy)
      throws IllegalArgumentException
    { 
        if (obj instanceof Boolean)
            //  il wrapper Boolean
            return ((Boolean)obj).booleanValue();
        // altro non si puo` convertire
        throw new IllegalArgumentException(obj+" non Boolean");
    } //[m][s] unwrap

    public static char unwrap(Object obj, char dummy)
    { 
        if (obj instanceof Character)
            //  il wrapper Character
            return ((Character)obj).charValue();
        return (char)toLong(obj);
    } //[m][s] unwrap

    public static byte unwrap(Object obj, byte dummy)
    { 
        return (byte)toLong(obj);
    } //[m][s] unwrap

    public static short unwrap(Object obj, short dummy)
    { 
        return (short)toLong(obj);
    } //[m][s] unwrap

    public static int unwrap(Object obj, int dummy)
    { 
        return (int)toLong(obj);
    } //[m][s] unwrap

    public static long unwrap(Object obj, long dummy)
    { 
        return toLong(obj);
    } //[m][s] unwrap

    public static float unwrap(Object obj, float dummy)
    { 
        return (float)toDouble(obj);
    } //[m][s] unwrap

    public static double unwrap(Object obj, double dummy)
    { 
        return toDouble(obj);
    } //[m][s] unwrap

    /**[m][s]
     * metodo di collaudo
     * @param args[0]  non usato
     */
    public static void main(String[] args)
    {
        boolean b = true;
        char c = 'C';
        byte y = -15;
        short s = 22;
        int i = 33;
        long l = -44;
        float f = 1.2f;
        double d = 3.4D;

        try
        {
        	
            System.out.println("boolean = "+unwrap(wrap(b), b));
            System.out.println("char = "+unwrap(wrap(c), c));
            System.out.println("byte = "+unwrap(wrap(y), y));
            System.out.println("short = "+unwrap(wrap(s), s));
            System.out.println("int = "+unwrap(wrap(i), i));
            System.out.println("long = "+unwrap(wrap(l), l));
            System.out.println("float = "+unwrap(wrap(f), f));
            System.out.println("double = "+unwrap(wrap(d), d));
            System.out.println("da character a long = "+unwrap(wrap(c), l));
            System.out.println("da character a double = "+unwrap(wrap(c), d));

            System.out.println("Adesso solleva eccezione:");
            System.out.println("da boolean a double = "+unwrap(wrap(b), d));
        }
        catch (IllegalArgumentException e)
        {
            System.out.println("Eccezione = "+e);
        }
    } //[m][s] main

} //{c} Wrapper

