package FI2.Gui;
/**{p}
 * -- FI2.Gui --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Interfaccia grafica
 */

/**{f}
 * AppletThUpdate.java
 * esempio di applet elementare eseguito come
 * thread senza repaint con diagnostica su stdout
 *
 * @version 1.00 98/12/08
 * @version 1.01 99/09/30 -
 * Thread.stop() deprecato, sostituito
 * con stopFlag
 * @author M.Moro DEI UPD
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

/**{c}
 * esempio di applet con contatori statici -
 * la diagnostica avviene su stdout (sulla
 * finestra di console java nel caso di un browser) -
 * l'esecuzione come thread garantisce l'aggiornamento
 * periodico della finestra ma la ridefinizione di update
 * non esegue il rinfresco mediante repaint, che
 * avviene su base periodica
 */
public class AppletThUpdate extends Applet 
implements Runnable 
{
    private static int x = 5;
    private static int y = 10;
    private Thread runner;
/*>> 1.1 Thread.stop deprecato
    variabile valutata in run()
*/
    private boolean stopFlag = false;
/*<< */

    /**[m]
     * @see Applet
     */
    public void init() { }

    /**[m]
     * @see Applet
     */
    public void start() 
    {
        if (runner == null)
        {
            // crea il thread che fa il repaint periodico
/*>> 1.1 Thread.stop deprecato
*/
            stopFlag = false;
/*<< */
            runner = new Thread(this);
            runner.start();
              // attiva il thread (il metodo run())
        }
    } //[m] start

    /**[m]
     * @see Applet
     */
    public void stop() 
    {
        if (runner != null)
        {
            // distrugge il thread di repaint
/*>> 1.1 Thread.stop deprecato
     sostituito con una variabile valutata periodicamente
     in run()
            runner.stop();
*/
            stopFlag = true;
/*<< */
            runner = null;
        }
    } //[m] stop

    /**[m]
     * @see Runnable
     */
    public void run() 
    {
        // metodo principale del thread
/*>> 1.1 Thread.stop deprecato
        while (true)
*/
        while (!stopFlag)
/*<< */
        {
            repaint();
            try
            {
                Thread.sleep(1000);
            }
            catch (InterruptedException e)
            {
            }
            y += 10;
            if (y > 200)
                y = 10;
        } // while
    } //[m] run

    /**[m]
     * @see Applet
     */
    public void update(Graphics g)
    {
        paint(g);
    } //[m] update

    /**[m]
     * @see Applet
     */
    public void paint(Graphics g) 
    {
        g.drawString("Sovrapporre, y=" + y, x, y);
    } //[m] paint

} //{c} AppletThUpdate
