package FI2.Gui;
/**{p}
 * -- FI2 --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Interfaccia grafica
 */

/**{f}
 * CanvasDrawTraversal.java
 * Visualizzazione grafica per applet di un albero
 * mediante visita in ordine -
 * software ricavato dalla libreria JDSL
 *
 * @version 3.00 00/09/29
 * @author M.Moro DEI UPD
 */

import java.awt.*;
import FI2.Set.*;
import FI2.Tree.*;

/**{c}
 * effettua la visualizzazione grafica in un Canvas
 * di un albero binario
 */
public class CanvasDrawTraversal extends EulerTour {
  // Traversal of a binary tree that is specialized 
  // to draw a binary tree within an applet. 
  // It is assumed that the elements stored at
  // the nodes of the binary tree are of type DrawingInfo
  protected int offset = 20; // size of the grid squares
  protected int radius = 16; 
    // radius of circles and side of squares
  protected Graphics g;
  public CanvasDrawTraversal(Graphics gg) { g = gg; }
  public Object execute(BinaryTree T) {
    super.execute(T);
    eulerTour(tree.root());
    return null;  // nothing interesting to return
  }
  protected void visitExternal(Position p, TraversalResult r) {
    // Draw an external node as a black square
    g.setColor(((DrawingInfo)p.element()).getColor());
    g.fillRect(xCorner(p),yCorner(p),radius,radius);
  }
  protected void visitLeft(Position p, TraversalResult r) {
    // Draw the edge to the left child
    g.setColor(Color.black);
    g.drawLine(xPos(p), yPos(p), xPos(tree.leftChild(p)),
           yPos(tree.leftChild(p)));
  }
  protected void visitBelow(Position p, TraversalResult r) {
    // Draw the edge to the right child
    g.setColor(Color.black);
    g.drawLine(xPos(p), yPos(p), xPos(tree.rightChild(p)),
           yPos(tree.rightChild(p)));
  }
  protected void visitRight(Position p, TraversalResult r) {
    // Draw the internal node as a colored circle
    g.setColor(((DrawingInfo)p.element()).getColor());
    g.fillOval(xCorner(p), yCorner(p), radius, radius);
    g.setColor(Color.black);
    g.drawOval(xCorner(p), yCorner(p), radius, radius);
  }
  //end#fragment CanvasDrawTraversal
  //begin#fragment CanvasDrawTraversal2
  // Auxiliary methods for drawing the nodes
  protected int xCorner(Position p) {
    return (1+((DrawingInfo) 
      p.element()).getX())*offset-radius/2;
  }
  protected int yCorner(Position p) {
    return (1+((DrawingInfo)p.element()).getY())*
      offset-radius/2;
  }
  protected int xPos(Position p) {
    return (1+((DrawingInfo)p.element()).getX())*offset;
  }
  protected int yPos(Position p) {
    return (1+((DrawingInfo)p.element()).getY())*offset;
  }

} //{c} CanvasDrawTraversal

