package FI2.Gui;
/**{p}
 * -- FI2.Gui --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Interfaccia grafica
 */

/**{f}
 * MenuFrame.java
 * esempio di Frame con menu`
 *
 * @version 2.00 00/09/28
 * @author M.Moro DEI UPD
 */

import java.awt.*;
import FI2.Util.FI2Sys;

/**{c}
 * esempio di frame con menu`
 */
public class MenuFrame extends Frame 
{
    // componenti
    MenuItem fileNew = new MenuItem("New");
    MenuItem fileOpen = new MenuItem("Open...");
    MenuItem fileSave = new MenuItem("Save");
    MenuItem fileExit = new MenuItem("Exit");
    MenuItem editUndo = new MenuItem("Undo");
    MenuItem editCut = new MenuItem("Cut");
    MenuItem editCopy = new MenuItem("Copy");
    MenuItem editPaste = new MenuItem("Paste");
    MenuItem helpContents = new MenuItem("Contents");
    MenuItem helpAbout = new MenuItem("About MenuFrame...");
    
    /**[c]
     * costruttore base, aggiunge al frame tutti i
     * componenti previsti
     */
    public MenuFrame() 
    {
        super("Menu example");
        
        MenuBar menubar = new MenuBar();
        Menu fileMenu = new Menu("File");
        Menu editMenu = new Menu("Edit");
        Menu helpMenu = new Menu("Help");
        
        fileMenu.add(fileNew);
        fileMenu.add(fileOpen);
        fileSave.setEnabled(false);
        fileMenu.add(fileSave);
        fileMenu.addSeparator();
        fileMenu.add(fileExit);
        
        editMenu.add(editUndo);
        editMenu.addSeparator();
        editMenu.add(editCut);
        editMenu.add(editCopy);
        editMenu.add(editPaste);
        
        helpMenu.add(helpContents);
        helpMenu.addSeparator();
        helpMenu.add(helpAbout);
        
        menubar.add(fileMenu);
        menubar.add(editMenu);
        menubar.add(helpMenu);
        menubar.setHelpMenu(helpMenu);
        
        setMenuBar(menubar);
        
        setSize(new Dimension(400, 300));

        Dimension screenSize = 
          Toolkit.getDefaultToolkit().getScreenSize();
        Dimension mySize = getSize();
        
        setBounds((screenSize.width-mySize.width)/2, 
          (screenSize.height-mySize.height)/2, 
          mySize.width, mySize.height);
        
        show();
    } //[c] MenuFrame

    /**[m][s]
     * metodo di attivazione
     * @param args[]  non usato
     */
    public static void main(String[] args) 
    {
        FI2Sys.out.println(
"Alla fine chiudere la finestra\ninterrompendo il processo (Ctrl-C o simile)");
        MenuFrame me = new MenuFrame();
    } //[m][s] main

} //{c} MenuFrame
