package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * DLNode.java
 * Modello di nodo per una lista concatenata doppia
 *
 * @version 1.00 98/08/04
 * @author M.Moro DEI UPD
 */


/**{c}
 * nodo di lista concatenata doppia -
 * i metodi sono quasi tutti a visibilita` protected perche'
 * di uso interno ai metodi per strutture lineari ma
 * eventualmente ereditabili da classe estese in altri
 * package
 */
class DLNode
{
    private Object element;  // valore associato
    private DLNode next, prev; 
      // elemento successivo e precedente

    /**[c]
     * costruttore di default
     */
    public DLNode()
    { this(null, null, null); }

    /**[c]
     * costruttore con oggetto associato
     * @param e  l'oggetto associato
     * @param p  nodo precedente
     * @param n  nodo successivo
     */
    protected DLNode(Object e, DLNode p, DLNode n)
    {
        element = e;
        next = n;
        prev = p;
    } //[c] DLNode

    // metodi d'accesso

    /**[m]
     * metodo di lettura dell'oggetto
     * @return l'oggetto associato
     */
    protected Object getElement()
    { return element; }

    /**[m]
     * metodo di lettura del successore
     * @return riferimento al nodo successivo
     */
    protected DLNode getNext()
    { return next; }

    /**[m]
     * metodo di lettura del predecessore
     * @return riferimento al nodo precedente
     */
    protected DLNode getPrev()
    { return prev; }

    // metodi di aggiornamento

    /**[m]
     * metodo di modifica dell'oggetto
     * @param newElem l'oggetto da assegnare
     */
    protected void setElement(Object newElem)
    { element = newElem; }

    /**[m]
     * metodo di modifica del successore
     * @param newNext in nuovo nodo successivo
     */
    protected void setNext(DLNode newNext)
    { next = newNext; }

    /**[m]
     * metodo di modifica del predecessore
     * @param newPrev in nuovo nodo precedente
     */
    protected void setPrev(DLNode newPrev)
    { prev = newPrev; }

} //{c} DLNode
