package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * Deque.java
 * interfaccia per una coda doppia
 *
 * @version 1.00 98/08/04
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.DequeEmptyException;

/**{i}
 * generica coda doppia -
 * potrebbe estendere Container ma non viene fatto
 * per uniformita` con [Good] pag. 166
 */
public interface Deque
{
    // metodi di accesso

    /**[m][a]
     * numero degli elementi nella coda doppia
     * @return numero elementi corrente
     */
    int size();

    /**[m][a]
     * verifica se coda doppia vuota
     * @return true se coda doppia vuota;
     *         false altrimenti
     */
    boolean isEmpty();

    /**[m][a]
     * oggetto in testa alla coda doppia -
     * viene sollevata l'eccezione
     * DequeEmptyException in caso di coda doppia vuota
     * @return  l'oggetto se la coda doppia non e` vuota
     * @exception DequeEmptyException  coda doppia vuota
     */
    Object first() throws DequeEmptyException;

    /**[m][a]
     * oggetto in coda alla coda doppia -
     * viene sollevata l'eccezione
     * DequeEmptyException in caso di coda doppia vuota
     * @return  l'oggetto se la coda doppia non e` vuota
     * @exception DequeEmptyException  coda doppia vuota
     */
    Object last() throws DequeEmptyException;

    // metodi di aggiornamento

    /**[m][a]
     * inserisce un elemento come nuova testa -
     * qualche realizzazione puo` sollevare l'eccezione
     * DequeFullException
     * @param element  oggetto da inserire
     */
    void insertFirst(Object element);

    /**[m][a]
     * inserisce un elemento come nuova coda -
     * qualche realizzazione puo` sollevare l'eccezione
     * DequeFullException
     * @param element  oggetto da inserire
     */
    void insertLast(Object element);

    /**[m][a]
     * rimuove un elemento dalla testa della coda doppia -
     * viene sollevata l'eccezione
     * DequeEmptyException in caso di coda doppia vuoto
     * @return  l'oggetto se la coda doppia non e` vuota
     * @exception DequeEmptyException  coda doppia vuota
     */
    Object removeFirst() throws DequeEmptyException;

    /**[m][a]
     * rimuove un elemento dalla coda della coda doppia -
     * viene sollevata l'eccezione
     * DequeEmptyException in caso di coda doppia vuoto
     * @return  l'oggetto se la coda doppia non e` vuota
     * @exception DequeEmptyException  coda doppia vuota
     */
    Object removeLast() throws DequeEmptyException;

} //{i} Deque
