package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * InspectablePriorityQueue2.java
 * interfaccia che estende con gestione 
 * di riferimenti (Locator)
 * il InspectablePriorityQueue -
 * derivata da SimplePriorityQueue della v 1.x 
 *
 * @version 2.00 00/09/25
 * @author M.Moro DEI UPD
 */

import FI2.Set.Locator;
import FI2.Set.InspectableLocatorKeyBasedContainer;
import FI2.Exceptions.EmptyContainerException;

/**{i}
 * coda a priorita` con metodi a sola
 * lettura e riferimenti (Locator)
 * @see InspectablePriorityQueue
 * @see InspectableLocatorKeyBasedContainer
 */
public interface InspectablePriorityQueue2 
  extends InspectablePriorityQueue, 
  InspectableLocatorKeyBasedContainer
{
    /**[m][a]
     * ricerca l'Item con chiave minima e
     * ne restituisce il riferimento (Locator)
     * @return riferimento all'item 
     *         corrispondente alla chiave minima
     * @exception EmptyContainerException 
     * se la coda e` vuota
     */
    Locator min() throws EmptyContainerException;

} //{i} InspectablePriorityQueue2
