package FI2.Linear;
/**{p}
 * -- FI2.Linear --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Strutture lineari
 */

/**{f}
 * NSNode.java
 * Nodo-posizionatore per una lista concatenata doppia
 *
 * @version 1.00 98/08/12
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidPositionException;
import FI2.Set.Container;
import FI2.Set.Position;

/**{c}
 * nodo di lista concatenata doppia
 * come posizionatore -
 * il nome della classe compare in [Good] pag. 127
 */
class NSNode extends DLNode implements Position
{
    private Container cont;  // contenitore associato

    /**[c]
     * costruttore di default, posizionatore illegale
     */
    public NSNode()
    {
        super();
        cont = null;
    } //[c] NSNode

    /**[c]
     * costruttore con oggetto associato
     * @param e  l'oggetto associato
     * @param p  nodo precedente
     * @param n  nodo successivo
     */
    protected NSNode(NSNode newPrev, NSNode newNext, 
      Container container, Object elem)
    {
        super(elem, newPrev, newNext);
        cont = container;
    } //[c] NSNode

    /**[m]
     * @see Position
     */
    public Object element() throws InvalidPositionException
    {
        if (cont==null)
            throw new InvalidPositionException(
              "In NSNode.element");
        return getElement();
    } //[m] element

    /**[m]
     * per completezza, esistendo il costruttore nullo,
     * un posizionatore puo` effettivamente essere illegale
     * @see Position
     */
    public Container container() 
      throws InvalidPositionException
    {
        if (cont==null)
            throw new InvalidPositionException(
              "In NSNode.container");
        return cont;
    } //[m] container

    /**[m]
     * ritorna l'elemento 'indicato' dal posizionatore
     * assunto corretto
     * @return elemento associato
     */
    protected Object getElement() 
    { return super.getElement(); }

    /**[m]
     * aggiorna l'elemento 'indicato' dal posizionatore
     * @param elem  elemento da assegnare
     */
    protected void setElement(Object elem) 
    { super.setElement(elem); }

    /**[m]
     * metodo di modifica del contenitore
     * @param newCont il contenitore da assegnare
     */
    protected void setContainer(Container newCont)
    { cont = newCont; }

} //{c} NSNode

