package FI2.Network;
/**{p}
 * -- FI2.Network --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Rete
 */

/**{f}
 * ClientTCP.java
 * esempio di client su socket TCP
 *
 * @version 1.00 99/11/13
 * @author L.Calvi ITIS Negrelli Feltre (BL)
 * @author M.Moro DEI UPD
 */

import java.net.*;
import java.io.*;

/**{c}
 * esempio di client su porta TCP
 */
public class ClientTCP
{
    /**[m][s]
     * metodo di attivazione
     * @param args[0]  id server
     * @param args[1]  numero porta
     */
    public static void main(String[] args) throws IOException
    {
        String ipserver;
        int nporta;
        final int N = 10;  // n. massimo di messaggi scambiati con il server
        Socket s;
        DataInputStream dis;
        DataOutputStream dos;

        if (args.length < 2)
        {
            System.out.println("Sintassi: java ClientTCP "+
                               "<IPServer> <nPortaServer>");
            System.exit(-1);
        }

        // definizione dei parametri di connessione al server
        ipserver = args[0];
        nporta = Integer.parseInt(args[1]);

        // richiesta ed apertura della connessione: se il server non e' in
        // ascolto viene sollevata una java.net.ConnectException
        s = new Socket(ipserver,nporta);

        // creazione di un DataInputStream connesso
        // all' InputStream del Socket s
        dis = new DataInputStream(s.getInputStream());

        // creazione di un DataOutputStream connesso
        // all'OutputStream del Socket s
        dos = new DataOutputStream(s.getOutputStream());

        // dialogo del client con il server
        for (int i=1; i<=N; i++)
        {
            String msg = dis.readUTF();
            System.out.println("il CLIENT ha ricevuto il -> " + msg);
            msg = (Math.random()<.1)?"stop":"messaggio N."+i+" dal CLIENT";
            dos.writeUTF(msg);
            if (msg.equals("stop")) 
            {
                System.out.println("il CLIENT ha terminato");
                break;
            }
        } //for

        dis.close();
        dos.close();
        s.close();
    } //[m][s] main

} //{c} ClientTCP
