package FI2.Set;
/**{p}
 * -- FI2.Set --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Insiemi
 */

/**{f}
 * ArraySet.java
 * realizzazione di un insieme con vettore espandibile -
 * derivata da ExpArrSet della v 1.x 
 *
 * @version 2.00 00/09/27
 * @author M.Moro DEI UPD
 */

import FI2.Linear.Vector;
import FI2.Linear.ArrayVector;
import FI2.Util.FI2Sys;
import FI2.Exceptions.InvalidElementException;

/**{c}
 * realizzazione di un insieme generico di Object
 * senza ripetizione di oggetti e supporto
 * con vettore espandibile -
 * @see GenericSet
 */
public class ArraySet extends GenericSet
{
    Vector S;  // Set
    // l'ultima posizione occupata e` size-1

    /**[c]
     * costruttore base, Set vuoto
     */
    public ArraySet()
    {
        super();
        S = new ArrayVector();
    } //[c] ArraySet

    /**[m]
     * @see InspectableContainer
     */
    public ObjectIterator elements()
    {
        return S.elements();
    }

    /**[m]
     * @see Container
     */
    public Container newContainer()
    {
        return new ArraySet();
    } //[m] newContainer

    /**[m]
     * O(n)
     * @see GenericSet
     */
    protected void addElem(Object obj)
    {
        S.insertAtRank(size++, obj);
    } //[m] addElem

    /**[m]
     * O(n)
     * @see GenericSet
     */
    protected void remElem(Object obj)
    {
        int pos; // posizione da cercare

        for (pos=0; pos<size; pos++)
            if (obj.equals(S.elemAtRank(pos)))
                break;
        if (pos < size)
        {
            S.removeAtRank(pos);
            size--;
        }
    } //[m] remElem

    /**[m][s]
     * metodo di collaudo
     * @param args[]  non usato
     */
    public static void main(String[] args)
    {
        Set set1 = new ArraySet();
        Set set2 = new ArraySet();
        Set dom = new ArraySet();
        FI2Sys.out.println("Collaudo ArraySet");
        FI2Sys.out.println("set1 inizialmente e`" +
          " [" + (set1.isEmpty() ? "" : "non ") + "vuoto]" );


        Object val;

        for (int i=1; i<=15; i++)
        {
            do
                val =
                  new Integer((int)(Math.random() * 20));
            while (set1.contains(val));
                // elementi distinti
            set1.insertElement(val);
        } //for

        // l'insieme puo` essere disuniforme
        set1.insertElement("Stringa 1");
        set1.insertElement("Stringa 2");

        for (int i=1; i<=7; i++)
        {
            do
                val =
                  new Integer((int)(Math.random() * 20));
            while (set2.contains(val));
                // elementi distinti
            set2.insertElement(val);
        } //for

        // l'insieme puo` essere disuniforme
        set2.insertElement("Stringa 1");
        set2.insertElement("Stringa 3");

        for (int i=0; i<=21; i++)
        {
            val = new Integer(i);
            dom.insertElement(val);
                // dominio 0..21
        } //for

        // l'insieme puo` essere disuniforme
        dom.insertElement("Stringa 1");
        dom.insertElement("Stringa 2");
        dom.insertElement("Stringa 3");

        Set sTmp;
        FI2Sys.out.println("\nset1: " + set1);
        FI2Sys.out.println("\nset2: " + set2);
        FI2Sys.out.println("\nset1 inizialmente e` " +
          (set1.isEqual(set2) ? "uguale " : "diverso ") 
          + "da set2" );
        FI2Sys.out.println("\n~set1: " +
          set1.complement(dom));
        FI2Sys.out.println("\n~set2: " +
          set2.complement(dom));
        FI2Sys.out.println("\nset1 + set2: " +
          (sTmp = set1.union(set2)) +
          " [" + (sTmp.isEmpty() ? "" : "non ") + "vuoto]" );
        FI2Sys.out.println("\nset1 & set2: " +
          (sTmp=set1.intersect(set2)) +
          " [" + (sTmp.isEmpty() ? "" : "non ") + "vuoto]" );
        FI2Sys.out.println("\nset1 - set2: " +
          (sTmp = set1.subtract(set2)) +
          " [" + (sTmp.isEmpty() ? "" : "non ") + "vuoto]" );
        try
        {
            ((GenericSet)set1).insertElement(
              new Integer(2000), dom);
            // per provocare l'eccezione
        }
        catch (InvalidElementException ex)
        {
            // cattura
            FI2Sys.out.println(ex + "<<-- !!!");
        } //catch

        FI2Sys.out.println("\nIl dominio era (size=" + 
          dom.size() + "): " + dom);
        dom.removeElement("Stringa 2");
        FI2Sys.out.println(
          "\nIl dominio dopo la rimozione (size=" + 
          dom.size() + "): " + dom);
    } //[m] main

} //{c} ArraySet
