package FI2.Set;
/**{p}
 * -- FI2.Set --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Insiemi
 */

/**{f}
 * Item.java
 * coppia chiave-oggetto
 *
 * @version 1.00 98/08/15
 * @author M.Moro DEI UPD
 */

/**{c}
 * realizzazione di un insieme coppia
 * costituito da una chiave che esprime un
 * ordinamento totale e un oggetto associato -
 * i metodi sono tutti pubblici per consentirne
 * la manipolazione alle applicazioni
 */
public class Item 
{
    private Object key, elem;
      // la coppia chiave-oggetto

    /**[c]
     * costruttore base
     * @param k  chiave
     * @param e  oggetto
     */
    public Item (Object k, Object e) 
    {
        key = k;
        elem = e;
    } //[c] Item

    /**[m]
     * la chiave della coppia
     * @return la chiave
     */
    public Object key() { return key; }

    /**[m]
     * l'oggetto della coppia
     * @return l'oggetto
     */
    public Object element() { return elem; }

    /**[m]
     * imposta la chiave della coppia
     * @param k  la chiave
     */
    public void setKey(Object k) { key = k; }

    /**[m]
     * imposta l'oggetto della coppia
     * @param k  l'oggetto
     */
    public void setElement(Object e) { elem = e; }

    /**[m] !!
     * conversione a stringa
     * @return stringa con il contenuto
     */
    public String toString()
    {
        return "Item key=" + key + " el=" + elem;
    } //[m] toString

} //{c} Item
