package FI2.Set;
/**{p}
 * -- FI2.Set --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Insiemi
 */

/**{f}
 * Item2.java
 * coppia chiave-oggetto che implementa Locator -
 * derivata da LocItem della v 1.x 
 *
 * @version 2.00 00/09/24
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidLocatorException;

/**{c}
 * estensione di Item per implementare Locator -
 * i metodi non di Locator sono protected: gli
 * utilizzatori nella libreria definiranno una
 * propria versione estesa in modo da rendere
 * la visibilita` package
 */
public class Item2 extends Item implements Locator  
{
    private Container cont;  // contenitore
    private Position pos;  // posizionatore

    /**[c]
     * costruttore base
     * @param k  chiave
     * @param e  oggetto
     * @param c  contenitore
     * @param p  posizionatore
     */
    protected Item2 (Object k, Object e, Container c, 
      Position p) 
    {
        super(k, e);
        cont = c;
        pos = p;
    } //[c] LocItem

    /**[m]
     * @see Locator
     */
    public boolean isContained() 
      throws InvalidLocatorException 
    { return cont != null; }

    /**[m]
     * @see Locator
     */
    public Container container() 
      throws InvalidLocatorException 
    { return cont; }

    /**[m]
     * il posizionatore associato
     * @return posizione associata
     */
    protected Position position() 
    { return pos; }

    /**[m]
     * imposta il posizionatore associato
     * @param p  posizione da assegnare
     */
    protected void setPosition(Position p) 
    { pos = p; }

    /**[m]
     * imposta il contenitore associato
     * @param c  contenitore da assegnare
     */
    protected void setContainer(Container c) 
    { cont = c; }

} //{c} Item2

