package FI2.Set;
/**{p}
 * -- FI2.Set --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Insiemi
 */

/**{f}
 * Locator.java
 * interfaccia per un riferimento (Locator)
 *
 * @version 1.00 98/09/17
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidLocatorException;
import FI2.Exceptions.UncontainedLocatorException;
import FI2.Set.Container;

/**{i}
 * riferimento per un elemento in un contenitore
 */
public interface Locator 
{
    /**[m][a]
     * elemento dell'item 'indicato' dal riferimento
     * @return elemento indicato
     * @exception InvalidLocatorException 
     * riferimento non valido o invalidato
     */
    Object element() throws InvalidLocatorException;

    /**[m][a]
     * chiave dell'item 'indicato' dal riferimento
     * @return chiave associata all'elemento indicato
     * @exception InvalidLocatorException 
     * riferimento non valido o invalidato
     */
    Object key() throws InvalidLocatorException;
    
    /**[m][a]
     * verifica se il riferimento indica un
     * item contenuto in un contenitore
     * @return true se contenuto, false altrimenti
     * @exception InvalidLocatorException 
     * riferimento non valido o invalidato
     */
    boolean isContained() throws InvalidLocatorException;

    /**[m][a]
     * contenitore che contiene l'item 
     * indicato dal riferimento
     * @return contenitore associato
     * @exception InvalidLocatorException 
     * riferimento non valido o invalidato
     * @exception UncontainedLocatorException
     * item non contenuto
     */
    public Container container() 
      throws InvalidLocatorException,
      UncontainedLocatorException;

} //{i} Locator
