package FI2.Set;
/**{p}
 * -- FI2.Set --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Insiemi
 */

/**{f}
 * PositionalContainer.java
 * contenitore-insieme con posizioni
 * e metodi read-write -
 * derivata da PositionalContainer della v 1.x 
 *
 * @version 2.00 00/09/20
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidPositionException;
import FI2.Exceptions.InvalidContainerException;

/**{i}
 * contenitore-insieme con posizioni  -
 * definisce una relazione di contiguita`
 * tra posizioni e consente di utilizzare i
 * posizionatori per le operazioni su strutture dati
 * @see Container
 */
public interface PositionalContainer 
  extends InspectableContainer, Container
{
    /**[m][a]
     * sostituisce l'elemento nella posizione fornita
     * @param p  posizione dell'elemento
     * @param newElement  nuovo oggetto
     * @return l'oggetto sostituito
     * @exception InvalidPositionException
     * posizionatore illegale
     * @exception InvalidContainerException
     * contenitore non valido
     */
    Object replaceElement(Position p, Object newElement)
      throws InvalidPositionException, 
      InvalidContainerException;

    /**[m][a]
     * scambia gli elementi alle due posizioni fornite
     * @param p  posizione del primo elemento
     * @param q  posizione del secondo elemento
     * @exception InvalidPositionException
     * posizionatore illegale
     * @exception InvalidContainerException
     * contenitore non valido
     */
    void swapElements(Position p, Position q)
      throws InvalidPositionException, 
      InvalidContainerException;

} //{i} PositionalContainer
