package FI2.Stream;
/**{p}
 * -- FI2.Stream --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Flussi
 */

/**{f}
 * FLoc.java
 * classe base per variabile su memoria virtuale
 *
 * @version 1.00 98/10/02
 * @author M.Moro DEI UPD
 */

import java.io.*;

/**{c}{a}
 * realizza il concetto di variabile mappata su un file
 * ad accesso casuale -
 * le classi derivate realizzano i vari tipi di variabili
 */
public abstract class FLoc
{
    FileMem fm; // la mappa su file
    int adr;  // indirizzo di allocazione
    int locSize;  // dimensione della variabile

    /**[c]
     * costruttore base -
     * utilizzato dai costruttori di
     * classe derivate per init della parte
     * ereditata
     * @param fMap  stream di mappa
     * @param size  estensione della variabile
     */
    FLoc(FileMem fMap, int size)
      throws IOException
    {
        fm = fMap;
        adr = fm.newLoc(locSize = size);
    } //[c] FLoc;

    /**[m]
     * 'distruttore' -
     * nel caso l'oggetto che rappresenta la
     * variabile 'virtuale' venga rimosso,
     * viene rilasciata anche la locazione su file
     */
    protected void finalize()
      throws IOException
    { 
        fm.freeLoc(adr, locSize); 
        adr = -1;
    } //[m] finalize

    /**[m]
     * metodo di lettura
     * @returns il valore letto
     */
    long rd()
      throws IOException
    { 
        if (adr == -1)
            throw new java.lang.NullPointerException(
              "Locazione non disponibile");
        return fm.getValue(adr, locSize); 
    } //[m] rd

    /**[m]
     * metodo di scrittura
     * @param val  valore da impostare
     */
    void wr(long val)
      throws IOException
    { 
        if (adr == -1)
            throw new java.lang.NullPointerException(
              "Locazione non disponibile");
        fm.setValue(adr, locSize, val); 
    } //[m] wr

} //{c} FLoc
