package FI2.String;
/**{p}
 * -- FI2.String --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Stringhe
 */

/**{f}
 * BruteForceMatch.java
 * ricerca di sottostringa con metodo
 * inefficiente
 *
 * @version 1.00 98/09/25
 * @author M.Moro DEI UPD
 */

import java.io.*;
import FI2.Util.FI2Sys;

/**{c}
 * realizza il metodo indexOf per la ricerca
 * della prima occorrenza di una sottostringa
 */
public class BruteForceMatch
{
    /**[m][s]
     * ricerca la seconda stringa (m car.) 
     * nella prima (n car.) con metodo semplice -
     * O(nm)
     * @param t  stringa in cui ricercare
     * @param p  sottostringa (pattern) da cercare
     * @return l'indice (0..n-m) della prima 
     *         occorrenza di p, se trovata;
     *         -1 altrimenti
     */
    public static int indexOf(String t, String p)
    {
        int n = t.length();  // lunghezze
        int m = p.length();
outloop:
        for (int i=0; i<=n-m; i++)
        {
            for (int j=0; j<m; j++)
                if (t.charAt(i+j) != p.charAt(j))
                  // carattere diverso, si va avanti
                  // di uno su t
                    continue outloop;
             // tutti gli m caratteri concidono
             return i;
        } //for i
        // sottostringa non trovata
        return -1;
    } //[m][s] size

    /**[m][s]
     * metodo di collaudo
     * @param args[0]  non usato
     */
    public static void main(String[] args)
    {
        String t = "0123456789abcdefghij";
        String p1 = "9abc";
        String p2 = "9abdef";
        String p3 = "efghij";
        FI2Sys.out.println(p1 + " in " + t + " = " +
          indexOf(t, p1));
        FI2Sys.out.println(p2 + " in " + t + " = " +
          indexOf(t, p2));
        FI2Sys.out.println(p3 + " in " + t + " = " +
          indexOf(t, p3));
    } //[m][s] main

} //{c} BruteForceMatch.java
