package FI2.Temi;
/**{p}
 * -- FI2.Temi --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Temi d'esame
 */

/**{f}
 * GInf.java
 * Interfaccia grafica con ascoltatore
 * Scritto del 20/9/99
 *
 * @version 1.00
 * @author M.Moro DEI UPD
 */

import java.awt.*;
import java.awt.event.*;
import FI2.Util.FI2Sys;
import FI2.Exceptions.QueueEmptyException;
import FI2.Exceptions.QueueFullException;
import FI2.Exceptions.StackFullException;


/* >>>>>>>>>>>>> la parte richiesta e' solo SetText:
il resto e' comunque funzionante */

/**{c}
 * interfaccia grafica come frame -
 * implementa alcuni ascoltatori
 */
public class GInf extends Frame 
implements WindowListener 
{
    // componenti 
    TextArea text1 = new TextArea("");
    TextArea text2 = new TextArea("");
    Button butt1 = new Button("Inserimento");
    Button butt2 = new Button("Estrazione");
    RBuf myBuf = new RBuf();

    /**[c]
     * costruttore base, aggiunge al frame tutti i
     * componenti previsti
     */
    public GInf() {
        super("GInf");
        addWindowListener(this);
        setLayout(new FlowLayout(FlowLayout.LEFT));

// >>>>>>>>>>> parte richiesta

        class SetText implements ActionListener
        {
        /**[m]
         * implementazione di ActionListener
         * @see ActionListener
         */
            public void actionPerformed(ActionEvent e) 
            {
                String buttonCommand = e.getActionCommand();
                if(buttonCommand.equals("Inserimento"))
                  // o altro modo per identificarlo
                {
                    // inserimento 
                    try
                    {
                        myBuf.insert(text1.getText());
                        text1.setText("");
                    }
                    catch (QueueFullException eq)
                    {
                        text1.setText("Troppi elementi in coda!");
                    }
                    catch (StackFullException es)
                    {
                        text1.setText("Buffer pieno, non inserito!");
                    }
                    text1.requestFocus(); // <<<<<<< NON RICHIESTO!
                }
                else 
                {
                    // estrazione
                    try
                    {
                        String s = (String) myBuf.remove();
                        text2.setText(s);
                    }
                    catch (QueueEmptyException eq)
                    {
                        text2.setText("Coda vuota!");
                    }
                    text1.requestFocus(); // <<<<<<< NON RICHIESTO!
                }
            } //[m] actionPerformed
        } //{c} SetText

// >>>>>>>>>>> fine parte richiesta

        add(text1);
        add(butt1);
        add(butt2);
        add(text2);
        SetText listener = new SetText();
        butt1.addActionListener(listener);
        butt2.addActionListener(listener);

        setSize(new Dimension(500, 400));
        show();
    }

    /**[m]
     * implementazione di WindowListener
     * @see WindowListener
     */
    public void windowClosing(WindowEvent e) {
        this.dispose();
        System.exit(0);
    }
    
    public void windowActivated(WindowEvent e) { }
    public void windowDeactivated(WindowEvent e) { }
    public void windowDeiconified(WindowEvent e) { }
    public void windowClosed(WindowEvent e) { }
    public void windowIconified(WindowEvent e) { }
    public void windowOpened(WindowEvent e) { }

    /**[m][s]
     * metodo di attivazione
     * @param args[]  non usato
     */
    public static void main(String[] args) 
    {
        GInf me = new GInf();
    }
} //{c} GInf

