package FI2.Temi;
/**{p}
 * -- FI2.Temi --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Temi d'esame
 */

/**{f}
 * SUS.java
 * Implementazione di SetDictionary -
 * Prova scritta Settembre 2000 1
 *
 * @version 1.00 2000/08/29
 * @author M.Moro DEI UPD
 */

import java.io.*;
import FI2.Util.*;
import FI2.Exceptions.*;
import FI2.Set.Container;
import FI2.Set.ObjectIterator;
import FI2.Dictionary.*;

public class SUS extends UnOrderedSLList 
implements SetDictionary 
{

    private Equality E;  // comparatore

    public SUS(Equality e)  // costruttori
    {
        super(e);
        E = e;
    }

    public SetDictionary union(SetDictionary d1)  // unione
    {
        // controllo comparatore
        if (E != ((SUS)d1).E)  
          // per semplicita` si assume esattamente lo stesso oggetto comparatore
          throw new IllegalArgumentException(
          "Comparatore di d1 diverso da quello di d0!");

        SetDictionary d2 = new SUS(E);

        ObjectIterator ks = keys();  // chiavi in d0

        // clone di d0
        while(ks.hasNext())
        {
            Object key = ks.nextObject();
            Object el = findElement(key);
            d2.insertItem(key, el); 
        } // while

        ks = d1.keys();  // chiavi in d1

        // altre chiavi
        while(ks.hasNext())
        {
            Object key = ks.nextObject();
            if (findElement(key) == Dictionary.NO_SUCH_KEY)
                // altra chiave
                d2.insertItem(key, d1.findElement(key)); 
        } // while
        return d2;
    } //[m] union

    public SetDictionary intersect(SetDictionary d1)  // intersezione
    {
        // controllo comparatore
        if (E != ((SUS)d1).E)  
          // per semplicita` si assume esattamente lo stesso oggetto comparatore
          throw new IllegalArgumentException(
          "Comparatore di d1 diverso da quello di d0!");

        SetDictionary d3 = new SUS(E);

        ObjectIterator ks = d1.keys();  // chiavi in d1

        while(ks.hasNext())
        {
            Object key = ks.nextObject();
            if (findElement(key) != Dictionary.NO_SUCH_KEY)
                // chiave anche in d0
            {
                Object el = d1.findElement(key);
                d3.insertItem(key, el);
            }
        } // while

        return d3;
    } //[m] intersect

    public SetDictionary subtract(SetDictionary d1)  // differenza
    {
        // controllo comparatore
        if (E != ((SUS)d1).E)  
          // per semplicita` si assume esattamente lo stesso oggetto comparatore
          throw new IllegalArgumentException(
          "Comparatore di d1 diverso da quello di d0!");

        SetDictionary d4 = new SUS(E);

        ObjectIterator ks = keys();  // chiavi in d0

        while(ks.hasNext())
        {
            Object key = ks.nextObject();
            if (d1.findElement(key) == Dictionary.NO_SUCH_KEY)
                // chiave non anche in d1
            {
                Object el = findElement(key);
                d4.insertItem(key, el);
            }
        } // while

        return d4;
    } //[m] subtract

    /**[m]
     * per forzare la chiave unica
     */
    public void insertItem(Object key, Object element)
      throws InvalidKeyException  
    {
        if (findElement(key) != Dictionary.NO_SUCH_KEY)
            throw new InvalidKeyException("Chiave gia` presente!");
        super.insertItem(key, element);
    } //[m] insertItem

    /**[m][s]
     * metodo di collaudo
     */
    public static void main(String[] args)
      throws IOException
    {
        Equality eq = new AKeyComp();
        BufferedReader re = new BufferedReader(new
          InputStreamReader(System.in));
        StreamTokenizer sIn = new StreamTokenizer(re);

        sIn.parseNumbers();

        FI2Sys.out.println(
"SUS: Battere lunghezza prima sequenza:"
              );

        sIn.nextToken();
        int len = (int)sIn.nval;
        FI2Sys.out.println("Numero elementi prima sequenza: " + len);
        re.readLine();  // per svuotare il buffer di input
        FI2Sys.out.println(
"Dizionario A: Battere chiave 6 caratteri + stringa:"
              );

        SUS da = 
          new SUS(eq);

        for (int i=1; i<=len; i++)
        {
            try
            {
                String str = re.readLine();
                da.insertItem(str.substring(0,6), 
                  str.substring(6));
                  // la chiave sono i primi 6 caratteri
                  // il resto i dati
            }
            catch (IOException e)
            {
                // termina il ciclo
            } //catch(EOF)
        } // for

        FI2Sys.out.println(da);

        FI2Sys.out.println(
"SUS: Battere lunghezza seconda sequenza:"
              );

        sIn.nextToken();
        len = (int)sIn.nval;
        FI2Sys.out.println("Numero elementi seconda sequenza: " + len);
        re.readLine();  // per svuotare il buffer di input
        FI2Sys.out.println(
"Dizionario B: Battere chiave 6 caratteri + stringa:"
              );

        SUS db = 
          new SUS(eq);

        for (int i=1; i<=len; i++)
        {
            try
            {
                String str = re.readLine();
                db.insertItem(str.substring(0,6), 
                  str.substring(6));
                  // la chiave sono i primi 6 caratteri
                  // il resto i dati
            }
            catch (IOException e)
            {
                // termina il ciclo
            } //catch(EOF)
        } // for

        FI2Sys.out.println(db);
        FI2Sys.out.println("-- Unione --");
        FI2Sys.out.println(da.union(db));
        FI2Sys.out.println("-- Intersezione --");
        FI2Sys.out.println(da.intersect(db));
        FI2Sys.out.println("-- Differenza --");
        FI2Sys.out.println(da.subtract(db));

    } //[m][s] main

/* non richiesti, per completezza */

    public SUS(Object k[], Object v[], Equality e)
    {
        super(k, v, e);
        E = e;
    }

    public Container newContainer()
    {
        return new SUS(E);
          // usa lo stesso comparatore di this
    } //[m] newContainer

} //{c} SUS

