package FI2.Temi;
/**{p}
 * -- FI2.Temi --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Temi d'esame
 */

/**{f}
 * TFifo.java
 * coda FIFO/TPrio
 * prova scritta del 5/9/2001
 *
 * @version 1.00
 * @author M.Moro DEI UPD
 */

import java.io.*;
import FI2.Linear.Queue;
import FI2.Linear.PriorityQueue;
import FI2.Linear.LinkedQueue;
import FI2.Linear.LinkedHeapPriorityQueue;
import FI2.Util.IntegerComparator;

// non richiesto
import FI2.Util.FI2Sys;

/**{c}
 * Vedi testo
 */
public class TFifo
{
    private Queue que;
    private PriorityQueue prio;
    
    class TFItem
    {
        Integer key;
        Object val;
        
        TFItem(Integer k, Object v)
        {
            key = k;
            val = v;
        } //[c]
        
        public String toString()
        {
            return "-->[TFitem] key=" + key +
              " value=" + val + "<--";
        }
    } //{c}{l} TFItem
    
    public TFifo()
    {
        que = new LinkedQueue();
        prio = new LinkedHeapPriorityQueue(new IntegerComparator());
    } //[c]
    
    public void insert(int tkey, Object val)
    {
        Integer key = new Integer(tkey);
          // chiave wrapped
        TFItem item = new TFItem(key, val);
          // capsula
          
        que.enqueue(item);
        prio.insertItem(key, item);
    } //[m] insert
    
    public Object deq()
    {
        if (que.isEmpty())
            // coda vuota
            return null;
            
        TFItem fifoItem = (TFItem) que.dequeue();
          // item estratto da FIFO
        Queue tmpque = new LinkedQueue();
          // coda temporanea
          
        while(!prio.isEmpty())
        {
            TFItem prioItem = (TFItem) prio.removeMin();
            if (prioItem == fifoItem)
            {
                // stesso item
                // rimette quelli estratti
                while (!tmpque.isEmpty())
                {
                    TFItem tmpItem = (TFItem) tmpque.dequeue();
                    prio.insertItem(tmpItem.key, tmpItem);
                } // while tmpqueue
                return fifoItem.val;
            }
            // else, inserisce nella coda temporanea
            tmpque.enqueue(prioItem);
        } // while
        // qui non dovrebbe mai arrivare
        return null;
    } //[m] deq

    public Object tdeq(int maxKey)
    {
        if (que.isEmpty())
            // coda vuota
            return null;
            
        // elimina il primo se ha chiave <=
        Integer tkey = (Integer)prio.minKey();
        if (tkey.intValue() > maxKey)
           // non estratto
           return null;
        // da estrarre
        TFItem prioItem = (TFItem) prio.removeMin();
        TFItem fifoItem;
        int size = que.size();
        
        for (int i=0; i<size; i++)
            if ((fifoItem = (TFItem) que.dequeue()) == prioItem)
                // stesso item
            {
                if (i != 0)
                    // se estrae il primo, la coda e`
                    // gia` a posto, altrimenti
                    // rimette a posto la coda
                    // con i rimanenti
                    for (int j=0; j<size-i-1; j++)
                    {
                        fifoItem = (TFItem) que.dequeue();
                        que.enqueue(fifoItem);
                    }
                return prioItem.val;
            }
            else
                // lo reinfila
                que.enqueue(fifoItem);
        // qui non dovrebbe mai arrivare
        return null;
    } //[m] tdeq

    // non richiesti
    public String toString()
    {
        return "TFifo [size=" + que.size() +
          "]: fifo\n" + que.toString() +
          "\n: prio\n" + prio.toString();
    } //[m] toString()
    

    /**[m][s]
     * metodo di collaudo
     * @param args[0]  numero dati
     * @exception IOException  se file non trovato 
     */
    public static void main(String[] args)
      throws IOException
    {
    
        String s1 = "Valore 1";
        String s2 = "Valore 2";
        String s3 = "Valore 3";
        
        TFifo tf = new TFifo();
        
        tf.insert(20, s1);
        tf.insert(10, s2);
        tf.insert(30, s3);
        tf.insert(35, s1);
        tf.insert(5, s2);
        
        System.out.println(tf);
        
        String x1 = (String)tf.deq();
        System.out.println("Dopo deq");
        System.out.println(tf);
        System.out.println("deq="+x1);
        x1 = (String)tf.tdeq(2);  // nessun estratto
        System.out.println("Dopo tdeq(2)");
        System.out.println(tf);
        System.out.println("tdeq(2)="+x1);
        x1 = (String)tf.tdeq(30);  // un estratto
        System.out.println("Dopo tdeq(30)");
        System.out.println(tf);
        System.out.println("tdeq(30)="+x1);


    } //[m][s] main

} //{c} TFifo

