package FI2.Tree;
/**{p}
 * -- FI2.Tree --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Alberi
 */

/**{f}
 * EvaluateDoubleExpressionTour.java
 * valutazione di espressione algebrica 
 * con valori integer e double su albero binario
 * (astratto) -
 * derivata da EvaluateExpressionTraversal della v 1.x
 *
 * @version 2.00 00/09/24
 * @author M.Moro DEI UPD
 */

import FI2.Set.Position;
import FI2.Util.VariableInfo;
import FI2.Util.IntegerVariableInfo;
import FI2.Util.DoubleVariableInfo;
import FI2.Util.OperatorInfo;
import FI2.Util.DoubleAdditionOperator;
import FI2.Util.DoubleSubtractionOperator;
import FI2.Util.DoubleOppositeOperator;
import FI2.Util.DoubleMultiplicationOperator;
import FI2.Util.DoubleDivisionOperator;
import FI2.Util.IntegerAdditionOperator;
import FI2.Util.IntegerSubtractionOperator;
import FI2.Util.IntegerOppositeOperator;
import FI2.Util.IntegerMultiplicationOperator;
import FI2.Util.IntegerDivisionOperator;
import FI2.Util.FI2Sys;

/**{c}
 * assume di ricevere un albero binario che esprime l'albero
 * astratto di una espressione algebrica e ne effettua il
 * calcolo attraverso una visita ricorsiva con il tour di
 * Eulero -
 * l'elemento memorizzato in cascuno dei nodi foglia 
 * e` un descrittore di operando (VariableInfo) 
 * mentre quello dei nodi interni e` un descrittore 
 * di operatore (OperatorInfo)
 * @see EulerTour
 * @see VariableInfo
 * @see OperatorInfo 
 */
public class EvaluateDoubleExpressionTour 
  extends EulerTour 
{
    /**[m]
     * @see EulerTour
     */
    public Object execute(InspectableBinaryTree T) 
    {
        super.execute(T);
        FI2Sys.out.println("L'espressione vale: ");
        Number theResult = (Number)eulerTour(tree.root());
        FI2Sys.out.println(theResult);
        return null;
    } //[m] execute

    /**[m]
     * @see EulerTour
     */
    protected void visitExternal(Position p, TraversalResult r)
    {
        VariableInfo v = (VariableInfo)p.element();
        r.finalResult = (v == null) ? null :
          v.variable(); 
          // sono gestiti anche operatori unari
          // per i quali il figlio di sinistra e` 
          // una foglia nulla
    } //[m] visitExternal

    // left e below non servono

    /**[m]
     * @see EulerTour
     */
    protected void visitRight(Position p, TraversalResult r)
    { 
        r.finalResult = ((OperatorInfo)p.element()).operation
          ((Number)r.leftResult, (Number)r.rightResult); 
    } //[m] visitRight

} //{c} EvaluateDoubleExpressionTour
