package FI2.Tree;
/**{p}
 * -- FI2.Tree --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Alberi
 */

/**{f}
 * EvaluateExpressionTour.java
 * valutazione di espressione algebrica su albero binario
 * (astratto) -
 * derivata da EvaluateExpressionTraversal della v 1.x
 *
 * @version 2.00 00/09/22
 * @author M.Moro DEI UPD
 */

import FI2.Set.Position;
import FI2.Util.OperatorInfo;
import FI2.Util.IntegerAdditionOperator;
import FI2.Util.IntegerSubtractionOperator;
import FI2.Util.IntegerOppositeOperator;
import FI2.Util.IntegerMultiplicationOperator;
import FI2.Util.IntegerDivisionOperator;
import FI2.Util.FI2Sys;

/**{c}
 * assume di ricevere un albero binario che esprime l'albero
 * astratto di una espressione algebrica e ne effettua il
 * calcolo attraverso una visita ricorsiva con il tour di
 * Eulero -
 * l'elemento memorizzato in cascuno dei nodi foglia 
 * e` un Integer mentre quello dei nodi interni 
 * e` un descrittore di operatore (OperatorInfo)
 * @see EulerTour
 * @see OperatorInfo 
 */
public class EvaluateExpressionTour 
  extends EulerTour 
{
    /**[m]
     * @see EulerTour
     */
    public Object execute(InspectableBinaryTree T) 
    {
        super.execute(T);
        FI2Sys.out.println("L'espressione vale: ");
        FI2Sys.out.println(eulerTour(tree.root()));
        return null;
    } //[m] execute

    /**[m]
     * @see EulerTour
     */
    protected void visitExternal(Position p, TraversalResult r)
    {
        r.finalResult = p.element(); 
          // sono gestiti anche operatori unari
          // per i quali il figlio di sinistra e` 
          // una foglia nulla
    } //[m] visitExternal

    // left e below non servono

    /**[m]
     * @see EulerTour
     */
    protected void visitRight(Position p, TraversalResult r)
    { 
        r.finalResult = ((OperatorInfo)p.element()).operation
          ((Integer)r.leftResult, (Integer)r.rightResult); 
    } //[m] visitRight

    /**[m][s]
     * metodo di collaudo
     * @param args[0]  non usato
     */
    public static void main(String[] args)
    {
    
        LinkedBinaryTree myTree = new LinkedBinaryTree();

        // costruisce un albero astratto di prova
        // corrisponde a: * (/ (~(5) 9) 10)
        // ovvero a: -5 / 9 * 10
        Position root = myTree.root();
        myTree.expandExternal(root);
        myTree.replaceElement(root, 
          new IntegerMultiplicationOperator());
        myTree.replaceElement(myTree.rightChild(root), 
          new Integer(10));
        Position p1 = myTree.leftChild(root);
        myTree.expandExternal(p1);
        myTree.replaceElement(p1, new IntegerSubtractionOperator());
        Position p2 = myTree.leftChild(p1);
        myTree.expandExternal(p2);
        myTree.replaceElement(p2, new IntegerOppositeOperator());
        myTree.replaceElement(myTree.rightChild(p2), 
          new Integer(5));
        myTree.replaceElement(myTree.rightChild(p1), 
          new Integer(9));
        FI2Sys.out.println("Albero Integer creato:\n" + 
          myTree);

        EvaluateExpressionTour Ev = 
          new EvaluateExpressionTour();
        Ev.execute(myTree);

    } //[m][s] main

} //{c} EvaluateExpressionTour
