package FI2.Tree;
/**{p}
 * -- FI2.Tree --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Alberi
 */

/**{f}
 * HeapTree.java
 * albero binario specializzato come heap -
 *
 * @version 1.00 00/09/24
 * @author M.Moro DEI UPD
 */

import FI2.Set.Position;
import FI2.Set.PositionalContainer;
import FI2.Exceptions.InvalidContainerException;
import FI2.Exceptions.EmptyContainerException;

/**{i}
 * albero binario come heap -
 * estende l'albero binario read-only con le
 * operazioni di modifica tipiche di un heap
 * @see InspectableBinaryTree
 * @see PositionalContainer
 */
public interface HeapTree 
  extends InspectableBinaryTree, PositionalContainer
{
    /**[m][a]
     * inserzione di un nuovo nodo nel successore
     * dell'ultima posizione dello heap, che diverra`
     * la nuova ultima posizione -
     * corrisponde alla sequenza delle seguenti tre operazioni:
     * expandExternal(last);
     * replaceElement(last, elem);
     * return last;
     * @param elem  elemento da aggiungere
     * @return la nuova ultima posizione
     * @exception InvalidContainerException
     * contenitore this illegale
     */
    Position add(Object elem)
      throws InvalidContainerException;

    /**[m][a]
     * rimozione del nodo in ultima posizione
     * @return l'elemento che era in ultima posizione
     * @exception EmptyContainerException
     * albero vuoto
     * @exception InvalidContainerException
     * contenitore this illegale
     */
    Object remove()
      throws EmptyContainerException, 
      InvalidContainerException;

} //{i} HeapTree
