package FI2.Util;
/**{p}
 * -- FI2.Util --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Utilita`
 */

/**{f}
 * Comparator.java
 * interfaccia per confronti
 *
 * @version 1.00 98/09/14
 * @author M.Moro DEI UPD
 */

import FI2.Exceptions.InvalidElementException;

/**{i}
 * consente la possibilita` di confronti d'ordinamento
 * tra oggetti generici, non inclusi - questo consente che
 * una coppia di oggetti esterni possa essere confrontata in
 * modi anche diversi
 */
public interface Comparator extends Equality
{
    /**[m][a]
     * confronto di maggiore
     * @param a  primo oggetto da confrontare
     * @param b  secondo oggetto da confrontare
     * @return true se a > b,
     *         false altrimenti
     * @exception InvalidElementException 
     * se oggetti non comparabili
     */
    boolean isGreaterThan (Object a, Object b)
      throws InvalidElementException;

    /**[m][a]
     * confronto di minore
     * @param a  primo oggetto da confrontare
     * @param b  secondo oggetto da confrontare
     * @return true se a < b,
     *         false altrimenti
     * @exception InvalidElementException 
     * se oggetti non comparabili
     */
    boolean isLessThan (Object a, Object b)
      throws InvalidElementException;

    /**[m][a]
     * confronto di maggiore o uguale
     * @param a  primo oggetto da confrontare
     * @param b  secondo oggetto da confrontare
     * @return true se a >= b,
     *         false altrimenti
     * @exception InvalidElementException 
     * se oggetti non comparabili
     */
    boolean isGreaterThanOrEqualTo (Object a, Object b)
      throws InvalidElementException;

    /**[m][a]
     * confronto di minore o uguale
     * @param a  primo oggetto da confrontare
     * @param b  secondo oggetto da confrontare
     * @return true se a <= b,
     *         false altrimenti
     * @exception InvalidElementException 
     * se oggetti non comparabili
     */
    boolean isLessThanOrEqualTo (Object a, Object b)
      throws InvalidElementException;

} //{i} Comparator
