package FI2.Util;
/**{p}
 * -- FI2.Util --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Utilita`
 */

/**{f}
 * FI2PS.java
 * conteggio righe di output
 *
 * @version 2.00 00/09/24
 * @author M.Moro DEI UPD
 */

import java.io.*;

/**{c}
 * aggiunge a PrintWriter il conteggio delle linee di
 * uscita con attesa ogni MAXLINES linee -
 * l'attesa ha luogo, con relativo invito, 
 * solo se il canale di input e` aperto -
 * si assume che PrintWriter chiami println()
 * al termine delle varie versioni di println con
 * parametro/i
 * @see PrintWriter
 */
public class FI2PS extends PrintWriter
{
    private int lines;
        // contatore linee di output
    private int maxLines;
        // numero di linee successive senza attesa

    /**[c]
     * costruttore base
     * @param out  stream di output
     * @param max  massimo numero di righe prima dell'attesa
     */
    public FI2PS(OutputStream out, int max)
    {
        super(out, true);
        lines = 1;
        maxLines = max;
    } //[c] FI2PS

    /**[m]
     * effettua il controllo con attesa dopo il numero
     * di righe prefissato 
     */
    private void control()
    {
        if (lines >= maxLines)
        {
            try
            {
                System.in.available();
                  // stampa avviso solo se l'input
                  // e` disponibile
                System.err.print(
                  "-- Continua -- (battere RETURN)");
                if (System.in.read() == '\r')
                    System.in.read();  // salta \n
            }
            catch(IOException e)
            {
                // nop
            } 
            lines = 1;
        }
        else
            lines++;
    } //[m] control

    /**[m]
     * aggiunge il controllo prima del fine riga 
     */
    public void println()
    {
        control();
        super.println();
    }

    /**[m]
     * controlla se la stringa e` divisa in piu` righe
     * @param s  stringa da emettere
     */
    public void println(String s)
    {
        int start = 0;
        while (start < s.length())
        {
            int last = s.indexOf('\n', start);
            if (last == -1)
            {
                // ultima porzione
                super.println(s.substring(start));
                  // chiama anche println() che chiama control
                start = s.length();
            } //if
            else
            {
                if (last >0 && s.charAt(last-1) == '\r')
                    // elimina CR
                    super.println(s.substring(start, last-1));
                else
                    super.println(s.substring(start, last));
                start = last+1;
            } //else
        } //while
    }

    /**[m]
     * consente di ricondurre alla versione stringa
     * nel caso di un oggetto generico
     * @param obj  oggetto con descrizione da emettere
     */
    public void println(Object obj)
    {
        println(obj.toString());
    }

} //{c} FI2PS


