package FI2.Util;
/**{p}
 * -- FI2.Util --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Utilita`
 */

/**{f}
 * Metrics.java
 * misure sugli algoritmi
 *
 * @version 2.00 98/08/09
 * @author M.Moro DEI UPD
 */

import java.io.*;

/**{c}
 * mette a disposizione un conteggio semplice, su confronto,
 * su scambio/spostamento e la memorizzazione del tempo
 */
public class Metrics
{
    public long readCnt,  // accesso semplice
                cmpCnt,  // su confronto
                swapCnt,  // su scambio/spostamento
                start,  // tempo assoluto d'avvio
                stop;  // tempo assoluto d'arresto

    /**[m]
     * effettua azzeramento contatori
     * e set di start
     */
    public void init()
    {
        readCnt = cmpCnt = swapCnt = stop = 0;
        start = System.currentTimeMillis();
    } //[m] init

    /**[m]
     * imposta fine conteggio tempo
     */
    public void end()
    {
        stop = System.currentTimeMillis();
    } //[m] end

    /**[m]
     * somma i risultati di due metriche
     */
    public void add(Metrics mel)
    {
        readCnt += mel.readCnt;
        cmpCnt += mel.cmpCnt;
        swapCnt += mel.swapCnt;
        // sposta stop in modo che la differenza
        // sia la somma delle differenze
        stop += mel.stop - mel.start;
    } //[m] add

    /**[m]
     * conversione a stringa -
     * produce il contenuto dei contatori
     * e l'intervallo temporale
     * @return stringa riassunto metriche
     */
    public String toString()
    {
        return "Read n." + readCnt + " Cmp n." + cmpCnt +
          " Swap/Move n." + swapCnt + " (Read+Move=" +
          (readCnt+swapCnt) + ") Durata " +
          (stop-start) + " ms";
    } //[m] toString

} //{c} Metrics
