package FI2.Util;
/**{p}
 * -- FI2.Util --
 * Universita' di Padova -
 * Diploma Universitario in Ingegneria Informatica
 * Corso di Fondamenti di Informatica 2
 * Utilita`
 */

/**{f}
 * VectorIter.java
 * vettore espandibile come iteratore
 * derivata da VectorEnum della v 1.x 
 *
 * @version 2.00 00/09/24
 * @author M.Moro DEI UPD
 */

import java.util.NoSuchElementException;
import FI2.Linear.ArrayVector;
import FI2.Set.ObjectIterator;

/**{c}
 * iteratore con una copia degli elementi inseriti
 * in un vettore espandibile - l'inserimento e` a carico
 * dell'utilizzatore - una volta riempito il vettore, gli
 * elementi vengono scorsi ed eliminati nell'ordine -
 * meccanismo inefficiente ma di uso generale
 * @see ObjectIterator
 */
public class VectorIter 
      extends ArrayVector implements ObjectIterator 
{

    /**[c]
     * costruttore di default
     */
    public VectorIter () { super (); }


    /**[m]
     * inserimento come nuovo ultimo
     * @param element  elemento da inserire
     */
    public void insertLast (Object element) 
    {
        insertAtRank(size(), element);
    }//[m] insertLast

    /**[m]
     * @see ObjectIterator
     */
    public boolean hasNext () 
    {
        return size() != 0;
    }//[m] hasNext


    /**[m]
     * @see ObjectIterator
     */
    public Object nextObject () 
      throws NoSuchElementException 
    {
        if (! hasNext())
            throw new NoSuchElementException
              ("Iterazione completa o vuota");
        return removeAtRank (0); // primo elemento
    }//[m] nextObject

}//{c} VectorIter
