// FinestraRam.java -- finestra di ingresso e uscita per Ram
// v 1.1 2 ottobre 1998

import java.awt.*;
import java.awt.event.*;
import java.io.*;

class FinestraRam extends Frame implements ActionListener {

  TextArea nastroDiIngresso;
  TextArea programma;
  TextArea nastroDiUscita;
  List errori;
  String[] righe;

  public FinestraRam () {
    setLayout(null);
    setTitle(getClass().getName());
    setBackground(Color.lightGray);
    addWindowListener(new FinestraCheSiChiude());
    MenuBar barra = new MenuBar();
    setMenuBar(barra);
    Menu menuIngresso = new Menu("ingresso");
    menuIngresso.add(new MenuItem("leggi"));
    menuIngresso.add(new MenuItem("scrivi"));
    menuIngresso.add(new MenuItem("nuovo"));
    menuIngresso.add(new MenuItem("azzera"));
    barra.add(menuIngresso);
    Menu menuUscita = new Menu("uscita");
    menuUscita.add(new MenuItem("scrivi"));
    menuUscita.add(new MenuItem("nuovo"));
    menuUscita.add(new MenuItem("azzera"));
    barra.add(menuUscita);
    Menu menuProgramma = new Menu("programma");
    menuProgramma.add(new MenuItem("leggi"));
    menuProgramma.add(new MenuItem("scrivi"));
    menuProgramma.add(new MenuItem("nuovo"));
    menuProgramma.add(new MenuItem("azzera"));
    barra.add(menuProgramma);
    Menu azione = new Menu("azione");
    azione.add(new MenuItem("vai"));
    barra.add(azione);
    azione.addActionListener(this);
    nastroDiIngresso = new TextArea();
    add(nastroDiIngresso);
    nastroDiIngresso.setBackground(Color.white); 
    nastroDiIngresso.setBounds(30, 60, 100, 350);
    nastroDiUscita = new TextArea();
    add(nastroDiUscita);
    nastroDiUscita.setBackground(Color.white);
    nastroDiUscita.setBounds(160, 60, 100, 350);
    programma = new TextArea();
    add(programma);
    programma.setBackground(Color.white); 
    programma.setBounds(290, 60, 200, 350);
    errori = new List();
    add(errori);
    errori.setBackground(Color.white);
    errori.setBounds(30,420,460,80);
    menuProgramma.addActionListener(new FileProgramma(this, programma));
    menuIngresso.addActionListener(new FileProgramma(this, nastroDiIngresso));
    menuUscita.addActionListener(new FileProgramma(this, nastroDiUscita));
    setSize(520,500);
    setVisible(true);
    }

  private String[] vettore (String str) {
    String[] datiLetti;
    if (str.length() == 0)
      datiLetti = new String[0];
    else {
      if (str.charAt(str.length() - 1) != '\n')
      str += '\n';
    // conta
      int n = 0;
      int i = 0;
      do {
        int j = str.indexOf('\n', i);
        n++;
        i = j + 1;
        } while(i < str.length());
    // divide in righe
      datiLetti = new String[n];
      int nn = 0;
      i = 0;
      do {
        int j = str.indexOf('\n', i);
        datiLetti[nn++] = str.substring(i, j);
        i = j + 1;
        } while(i < str.length());
      }
    return datiLetti;
    }

  public void actionPerformed (ActionEvent evt) {
    String comando = evt.getActionCommand();
    if (comando.equals("vai")) {
      String testoProgramma = programma.getText();
      String testoIngresso = nastroDiIngresso.getText();
      String[] vettoreProgramma = vettore(testoProgramma);
      String[] vettoreIngresso = vettore(testoIngresso);
      new XRam(vettoreProgramma, vettoreIngresso, nastroDiUscita, errori);
      }
    }

  public static void main(String[] argv) {
    new FinestraRam();
    }
  }
